import server.*;
import java.util.*;
import graphic.*;
import graphic.resources.*;
	
public class Run{
  public static void main(String[] argv){
		String title = "JQData.dk FTP Server v2.0";
		
		boolean visible = true;
		boolean started = false;
		boolean run     = true;
		
		for (int i = 0 ; i < argv.length ; i++) {
			if (argv[i].equals("-started"))
				started = true;
			if (argv[i].equals("-invisible"))
				visible = false;	
			if (argv[i].equals("-version")) {
				System.out.println();
				System.out.println(title);
				System.out.println("---------------------------");
				System.out.println("Created by Kenneth Vindum");				
				System.out.println("Denmark");
				run = false;
			}	
			if (argv[i].equals("-?") || argv[i].equals("/?")) {
				run = false;
				System.out.println();
				System.out.println("                  "+title);
				System.out.println("------------------------------------------------------------------------");
				System.out.println("Parameters: ");
				System.out.println("   -started       The server automatically starts listening for clients upon startup");
				System.out.println("   -invisible     Deactivates all user interfaces (NO GRAPHICS!)");
				System.out.println("   -version       Shows the current version");
				
			}
			
		}
		if (run) {		
			Server s = Server.instanceOf(title);
			Survailance.instanceOf();
			if (visible)
				new Main(s, title, visible);
			else {
				System.out.println( title + " has been started...");	
				s.setAutoSave(true);
			}
			
			if (started)
				s.start();
		}	
  }
}




/* TODO:
			 Detaljeringsgrad af informationer vist i hovedvinduets tekstArea.
			 Automatisk oprydning af LogFiler efter en bestemt alder.
			 Oversigt over kommandoer, som er send af klienter der aldrig kommer online.			 
	
	FIXED:
		Logfiles were never written at client disconnection
		Server IP now shows in mainwindow
		12 -> 24 hours support in filelisting.
		
*/
