package graphic;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.table.*;
import java.io.*;
import java.util.*;

import graphic.services.*;
import server.*;
import setup.*;

public class GroupAdmin extends MemoryFrame implements ActionListener{
	
	private JComboBox groupsComboBox;
	private JTextField groupnameField, loginsField, uploadField, downloadField;
	private JCheckBox readBox, listBox, writeBox;
	private ThreeClickCheckBox logBox, bounceBox;
	private JLabel groupnameLabel, logLabel, bounceLabel, loginsLabel, uploadLabel, downloadLabel, readLabel, listLabel, writeLabel, groupLabel;
	private JButton newGroupButton, deleteGroupButton, addDirButton, deleteDirButton, correctDirButton, okButton, annullerButton;
	private CountField loginCount, uploadCount, downloadCount;
	private JTable dirsTable;
	private DirData model;
	private Group[] groups;
	private JFileChooser fileChooser = new JFileChooser();
	private UserAdmin userAdmin;
	private JPanel bib;	
	private Group current;
		
	public GroupAdmin(UserAdmin userAdmin) {
		super("", "Group administration");
		this.userAdmin = userAdmin;
		setIconImage(ImageHandler.getImage("groups.gif"));
		setDefaultCloseOperation(WindowConstants.HIDE_ON_CLOSE);
		fileChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY); 
		GridBagGUI gbg = new GridBagGUI(getContentPane());
		
		gbg.position(0,0);
		gbg.insets(5,2,5,0);
		gbg.add(new JLabel(ImageHandler.getImageIcon("groups_big.gif")));
		
		groupsComboBox = new JComboBox();
		groupsComboBox.addActionListener(this);
		gbg.position(1,0);
		gbg.size(4,1);
		gbg.anchor("NW");
		gbg.fill('H');
		gbg.weightx(1);
		gbg.add(groupsComboBox);
		
		groupnameLabel = new JLabel();
		gbg.insets(3,2,0,0);
		gbg.position(0,1);
		gbg.size(1,2);
		gbg.fill('N');
		gbg.weightx(0);
		gbg.add(groupnameLabel);
		
		groupnameField = new JTextField(10);
		gbg.position(1,1);
		gbg.add(groupnameField);
		
		//Max Logins
		
		loginsLabel = new JLabel();
		gbg.position(2,1);
		gbg.size(1,2);
		gbg.insets(3,2,0,0);
		gbg.add(loginsLabel);
		
		gbg.position(3,1);
		loginCount = new CountField();
		loginsField = loginCount.field;
		gbg.add(loginCount);
		
		
		//Max upload
		
		uploadLabel = new JLabel();
		gbg.position(2,3);
		gbg.size(1,2);
		gbg.add(uploadLabel);

		uploadCount = new CountField();
		gbg.position(3,3);
		uploadField = uploadCount.field;
		gbg.add(uploadCount);
		
		//Max Download
		
		downloadLabel = new JLabel();
		gbg.position(2,5);
		gbg.size(1,2);
		gbg.insets(3,2,0,0);
		gbg.add(downloadLabel);
		
		downloadCount = new CountField();
		gbg.position(3,5);
		downloadField = downloadCount.field;
		gbg.add(downloadCount);
		
		//log
		logLabel = new JLabel();
		gbg.position(2,7);
		gbg.add(logLabel);
		
		logBox = new ThreeClickCheckBox("",res);
		gbg.size(1,1);
		gbg.position(3,7);
		gbg.add(logBox);
		
		// bounce attack
		bounceLabel = new JLabel();
		bounceLabel.setToolTipText("");
		gbg.position(2,8);
		gbg.add(bounceLabel);
			
		bounceBox = new ThreeClickCheckBox("",res);
		bounceBox.addActionListener(this);
		gbg.position(3,8);
		gbg.add(bounceBox);
		
		// ny, slet, log
		JPanel bp = new JPanel();
		GridBagGUI bg = new GridBagGUI(bp);
		gbg.insets(5,2,5,0);
		gbg.position(5,0);
		gbg.size(1,10);
		gbg.add(bp);
		
		newGroupButton = new JButton();
		newGroupButton.addActionListener(this);
		bg.insets(0,0,5,0);
		bg.fill('H');
		bg.position(0,0);
		bg.add(newGroupButton);
		
		deleteGroupButton = new JButton();
		deleteGroupButton.addActionListener(this);
		bg.position(0,1);
		bg.add(deleteGroupButton);

		okButton = new JButton();
		okButton.addActionListener(this);
		bg.position(0,2);
		bg.add(okButton);
		
		annullerButton = new JButton();
		annullerButton.addActionListener(this);
		bg.position(0,3);
		bg.add(annullerButton);
		
		// Biblioteker
		
		bib = new JPanel();
		GridBagGUI bibg = new GridBagGUI(bib);
		bib.setBorder(new TitledBorder(""));
		
		int[] size1  = {170,122};
		
		model = new DirData();
		dirsTable = new JTable();
		dirsTable.setAutoCreateColumnsFromModel(false);
		dirsTable.getTableHeader().setUpdateTableInRealTime(false);
		dirsTable.setModel(model);
		dirsTable.getTableHeader().setResizingAllowed(false);
		dirsTable.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		
    dirsTable.addColumn( new TableColumn(0,model.getColumnWidth(0)) );
    dirsTable.addColumn( new TableColumn(1,model.getColumnWidth(1)) );      

		dirsTable.addMouseListener(new MyMouseListener());		
		bibg.position(0,0);	
		bibg.anchor("NW");
		bibg.weightx(1);
		bibg.size(1,6);
		bibg.insets(5,15,15,5);
		JScrollPane js = new JScrollPane(dirsTable);
		js.setPreferredSize(new Dimension(295,185));
		js.getViewport().setBackground(new Color(255,255,255));
		bibg.add(js);
		
		readBox = new JCheckBox();
		readBox.addActionListener(this);
		bibg.weightx(0);
		bibg.size(1,1);
		bibg.position(1,0);
		bibg.insets(2,0,0,5);
		bibg.add(readBox);
		
		readLabel = new JLabel();
		bibg.position(2,0);
		bibg.add(readLabel);
		
		listBox = new JCheckBox();
		listBox.addActionListener(this);
		bibg.position(1,1);
		bibg.add(listBox);
		
		listLabel = new JLabel();
		bibg.position(2,1);
		bibg.add(listLabel);
		
		writeBox = new JCheckBox();
		writeBox.addActionListener(this);
		bibg.position(1,2);
		bibg.add(writeBox);
		
		writeLabel = new JLabel();
		bibg.position(2,2);
		bibg.add(writeLabel);		
		
		Dimension size = new Dimension(105,27);
		addDirButton = new JButton();
		addDirButton.setPreferredSize(size);
		addDirButton.addActionListener(this);
		bibg.position(1,3);
		bibg.size(2,1);
		bibg.add(addDirButton);
		
		deleteDirButton = new JButton();
		deleteDirButton.setPreferredSize(size);
		deleteDirButton.addActionListener(this);
		bibg.position(1,4);
		bibg.add(deleteDirButton);
		
		correctDirButton = new JButton();
		correctDirButton.setPreferredSize(size);
		correctDirButton.addActionListener(this);
		bibg.position(1,5);
		bibg.add(correctDirButton);
		
		gbg.insets(20,20,20,20);
		gbg.size(6,1);
		gbg.position(0,9);
		gbg.fill('B');
		gbg.weightx(1);
		gbg.weighty(1);
		gbg.add(bib);
		
		// Ok... s laver vi lige det sidste!!
		initializeData();
		
		setSize(502,480);
		restore();
		setResizable(false);
	}
	
	public void setText() {
		setTitle(res.getString("Group administration"));
		
		//.setText(res.getString(""));
		groupnameLabel.setText(res.getString("Groupname"));
		loginsLabel.setText(res.getString("Max Logins"));
		loginsLabel.setToolTipText(res.getString("Number of logins of a certain user on one ip adress"));
		uploadLabel.setText(res.getString("Max Upload KB"));
		uploadLabel.setToolTipText(res.getString("The number of KB that the client may send to the server pr. second."));
		downloadLabel.setText(res.getString("Max Download KB"));
		downloadLabel.setToolTipText(res.getString("The number of KB that the client may recive from the server pr. second."));
		logLabel.setText(res.getString("Log"));
		logBox.setName((res.getString("Log")));
		bounceLabel.setText(res.getString("Allow Bounce"));
		bounceBox.setName(res.getString("Allow Bounce Attack"));
		newGroupButton.setText(res.getString("Add")); 
		deleteGroupButton.setText(res.getString("Delete")); 
		okButton.setText(res.getString("OK")); 
		annullerButton.setText(res.getString("Cancel"));
		bib.setBorder(new TitledBorder(res.getString("Directories")));
		dirsTable.getColumnModel().getColumn(0).setHeaderValue(res.getString("Path"));
		dirsTable.getColumnModel().getColumn(1).setHeaderValue(res.getString("Alias"));
		readLabel.setText(res.getString("Read"));
		listLabel.setText(res.getString("List"));
		writeLabel.setText(res.getString("Write"));
		addDirButton.setText(res.getString("Add"));
		deleteDirButton.setText(res.getString("Delete"));
		correctDirButton.setText(res.getString("Edit")); 		
	}
		
	protected void initializeData() {
	
		groupsComboBox.removeAllItems();
		
		//Brugergrupper fyldes i listen!	
		XMLTag[] temp = Conf.getGroups();
		
		if (temp.length==0)  {
			newGroup();
		}else{
			for(int i = 0 ; i < temp.length; i++) {
				groupsComboBox.addItem(new Group(temp[i]));		
			}
		}
	}
	
	private Group newGroup() {
		XMLTag tag = new XMLTag("Usergroup");
		current = new Group(tag);
		setGroup(current);
		return current;
	}
	
	private void setCountText(CountField field, String value, String defaultValue) {
		field.field.setText(value);
		field.setDefaultValue(defaultValue);
	}
	
	public void setGroup(XMLTag xml) {
		Group g;
		for (int i = groupsComboBox.getItemCount()-1; i >= 0 ; i--) {
			g = (Group) groupsComboBox.getItemAt(i);
			if (g.xml == xml)
				groupsComboBox.setSelectedIndex(i);
		}
	}
	
	private void setGroup(Group group) {
		groupnameField.setText(group.getName());
		
		setCountText(loginCount,group.getLogins(),group.getDefault("max_logins_per_user"));
		setCountText(uploadCount,group.getUpload(),group.getDefault("max_client_upload"));
		setCountText(downloadCount,group.getDownload(),group.getDefault("max_client_download"));
		
		logBox.setState(group.getLog());
		bounceBox.setState(group.getBounce());
		
		group.fillDirs();
		
		readBox.setSelected(false);
		listBox.setSelected(false);
		writeBox.setSelected(false);
	}
	
	public void actionPerformed(ActionEvent e) {
		
		Object source = e.getSource();
		if (source == groupsComboBox) {
			if ( current != null && !(current.xml.getParent() == null && groupnameField.getText().equals(""))) {
				if (!current.save())
					return; // don't change the user! This one could not be be saved!
					
			}
			Group group = (Group)groupsComboBox.getSelectedItem();
			if (group != null) {
				current = group;
				setGroup(group);
			}
		}else if (source == deleteDirButton){
			int i = dirsTable.getSelectedRow();
			if (i >=0 ) 
				model.removeRow(i);
			readBox.setSelected(false);
			listBox.setSelected(false);
			writeBox.setSelected(false);			
		}else if(source == correctDirButton) {
			 int row = dirsTable.getSelectedRow();
			 if (row>=0) {
 			 	 Object o = dirsTable.getValueAt(row,0);
				 String path = o.toString();
				 fileChooser.setSelectedFile(new File(path));
				 int returnVal = fileChooser.showDialog(this,res.getString("OK"));
				 if (returnVal == JFileChooser.APPROVE_OPTION) {
				 	Dir d = (Dir)o;
					d.setDir(fileChooser.getSelectedFile().getAbsolutePath());
				 }
			 }
		}else if(source == listBox || source == readBox || source == writeBox){
			int row = dirsTable.getSelectedRow();
			if (row >= 0 ) {
				Dir dir = (Dir) dirsTable.getValueAt(row,0);
				dir.setList(listBox.isSelected());
				dir.setRead(readBox.isSelected());
				dir.setWrite(writeBox.isSelected());
			}
		}else if(source == okButton) {
			if ( groupsComboBox.getItemCount() == 0 && current.xml.getParent() == null && groupnameField.getText().equals(""))
				setVisible(false);
			else {
				if(current.save())
					setVisible(false);
			}
		}else if(source == annullerButton) {
			newGroup();
			setVisible(false);
		}else if(source == newGroupButton) {
			if (current!=null)
				current.save();
			newGroup();
		}else if(source == deleteGroupButton) {
			Group group = (Group) groupsComboBox.getSelectedItem();
			if (group != null) {
				int i = JOptionPane.showConfirmDialog(null, res.getString("Are you shure you wish to delete this group?"),res.getString("Shure?"), JOptionPane.YES_NO_OPTION);
				if (i == 0)  {
					newGroup();	
					group.getTag().getParent().removeTag(group.getTag());
					groupsComboBox.removeItem(group);
				}
			}else
				newGroup();
		}else if(source == addDirButton) {
			int returnVal = fileChooser.showDialog(this,res.getString("OK"));
    	if(returnVal == JFileChooser.APPROVE_OPTION) {
				boolean found = false;
				Dir d;
				for( int i = 0 ; i < dirsTable.getRowCount() ; i++) {
					d = model.getRow(i);
					if (d.getName().toLowerCase().equals(fileChooser.getSelectedFile().getAbsolutePath().toLowerCase()))
						found=true;	
				}
				if (!found) {
					Dir dir = new Dir(getNewDir(fileChooser.getSelectedFile().getAbsolutePath()),true,"User");
					model.add(dir);
					dirsTable.setRowSelectionInterval(dirsTable.getRowCount()-1,dirsTable.getRowCount()-1);
					readBox.setEnabled(true);
					listBox.setEnabled(true);
					writeBox.setEnabled(true);
					deleteDirButton.setEnabled(true);
					correctDirButton.setEnabled(true);
					readBox.setSelected(false);
					listBox.setSelected(false);
					writeBox.setSelected(true);
					readBox.doClick();
					listBox.doClick();
					writeBox.doClick();
				}else
		    	JOptionPane.showMessageDialog(null, res.getString("The Directory already exists. No action was taken."), res.getString("Notice") ,JOptionPane.INFORMATION_MESSAGE); 
    	}
		}
	}
	
	public void setVisible(boolean b) {
		super.setVisible(b);
		if (b == false) {
			Group g = (Group) groupsComboBox.getSelectedItem();
			if (g!=null)
				userAdmin.setGroup(g.xml);
		}
	}
	
	public XMLTag getNewDir(String navn) {
		XMLTag tag = new XMLTag("Directory");
		tag.addOption("name",navn);
		tag.addOption("list","no");
		tag.addOption("read","no");
		tag.addOption("write","no");
		return tag;
	}
	
	private class Group {
		public XMLTag xml;
		
		public Group(XMLTag xml) {
			this.xml=xml;
		}
		
		public XMLTag getTag() {
			return xml;
		}
		
		private String get(String option) {
			try {
				return xml.getOptionValue(option);
			}catch(NoSuchOptionException nse) {
				return "";
			}
		}
		
		public XMLTag[] getDirs() {
			try {
				return xml.getTagsLike("Directory");	
			}catch(NoSuchTagException nst) {
				return new XMLTag[] {};
			}	
		}
		
		public String getName() {
			return get("name");
		}
		
		public String toString() {
			return getName();
		}
		
		//skriver directories i dirstable.
		public void fillDirs() {
			Dir d;
			Object[] Oarr;

			//Brugergruppens biblioteker
			model.reset();
			XMLTag[] arr = getDirs();
			for(int i = 0 ; i < arr.length ; i++) {
				model.add( new Dir(arr[i],false, "Group"),0 );
			}
		}

		public int getLog() {
			return getBooleanFromUser("log");
		}
		
		public int getBounce() {
			return getBooleanFromUser("allow_bounce_attack");
		}
				
		private int getBooleanFromUser(String option) {
			int state = ThreeClickCheckBox.DISABLED;
			try {
				String str = xml.getOptionValue(option);
				if (str.equals("yes"))
					state = ThreeClickCheckBox.SELECTED;
				else if (str.equals("no"))
					state = ThreeClickCheckBox.DESELECTED;
			}catch(NoSuchOptionException nse) {
			}
			return state;		
		}
		
		private void setBool(String option, int state) {
			String ok=null;
			switch (state) {
				case ThreeClickCheckBox.SELECTED:
					ok="yes";
					break;
				case ThreeClickCheckBox.DISABLED:
					ok=null;
					break;
				case ThreeClickCheckBox.DESELECTED:
					ok="no";
					break;
			}	
			set(option,ok);
		}
		
		public String getUpload() {
			return get("max_client_upload");
		}
		
		public String getDownload() {
			return get("max_client_download");
		}
		
		public String getLogins() {
			return get("max_logins_per_user");
		}
		
		public String getDefault(String value) {
			String val = null;
			try{
				val = Conf.getRoot().getQuickOptionValue("Server."+value);
			}catch(NoSuchTagException nsoe) {
				//Fejl! Der var ikke deffineret en default vrdi for serveren
			}
			return val;
		}

		private void set(String option, String value) {
			try {
				if (value == null) {
					xml.removeOption(option);
				}else {
					try {
						xml.setOptionValue(option, value);
					}catch(NoSuchOptionException nse) {
						xml.addOption(option, value);
					}
				}
			}catch(NoSuchOptionException nse) {
				//Option eksisterer ikke / er allerede slettet.
			}
		}
		
		public boolean save() {
			if (groupnameField.getText().equals("")) {
				JOptionPane.showMessageDialog(null, res.getString("A Groupname MUST be deffined."), res.getString("Notice"),JOptionPane.WARNING_MESSAGE); 
				groupnameField.requestFocus();
				return false;
			}
			
			set("name", groupnameField.getText());
			set("max_client_upload", uploadCount.getValue());
			set("max_client_download", downloadCount.getValue());
			set("max_logins_per_user", loginCount.getValue());
			setBool("log", logBox.getState());
			setBool("allow_bounce_attack", bounceBox.getState());
			
			int size = dirsTable.getRowCount();
			Dir dir;

			//Tilfj nye tags, og saver alle
			for(int i = 0 ; i < size ; i++) {
				dir = model.getRow(i);;
				if (dir.isNew())
					xml.addTag(dir.getTag());
				dir.save();	
			}
			//Fjern slettede tags
			XMLTag[] dirs = getDirs(); 
			boolean found;
			for (int i = 0 ; i < dirs.length; i++) {
				found = false;
				for (int j = 0 ; j < size; j++) {
					dir = model.getRow(j);
					if (dir.equals(dirs[i])) {
						found = true;
						break;
					}
				}
				if (!found)
					xml.removeTag(dirs[i]);	
			}
			
			
			//Checker om brugeren er nyoprettet
			if (current.xml.getParent() == null) {
				try {
					Conf.getRoot().getTagLike("Users").addTag(current.xml);
					groupsComboBox.addItem(current);
					groupsComboBox.setSelectedItem(current);
				}catch(NoSuchTagException nse) {
				}
			}
			
			return true;
		}
	}
	
	private class Dir {
		
		private XMLTag xml;
		private boolean read,list,write,newOne;
		private Boolean home;
		private String parent,alias;
		
		public Dir(XMLTag xml, boolean newOne, String parent) {
			this.xml = xml;
			this.newOne = newOne;
			this.parent = parent;
			read  = get("read").equals("yes");
			list  = get("list").equals("yes");
			write = get("write").equals("yes");
			alias = get("alias");
			home  = new Boolean(get("home").equals("yes"));
		}
		
		public void setDir(String path) {
			try {
				xml.setOptionValue("name",path);
			}catch(NoSuchOptionException nse) {
			}
		}
		
		public String getParent() {
			return parent;
		}
		
		public boolean equals(XMLTag xml) {
			return this.xml == xml;
		}
		
		public boolean isNew() {
			return newOne;
		}
		
		public Boolean isHome() {
			return home;
		}
		
		public String toString() {
			return get("name");
		}
		
		public String getName() {
			return get("name");
		}
		
		public String getAlias() {
			return alias;
		}
		
		public void setAlias(String alias) {
			this.alias = alias;
		}
		
		public void setHome(Boolean home) {
			this.home = home;
		}
		
		public void setRead(boolean on) {
			read = on;
		}
		
		public void setList(boolean on) {
			list = on;
		}
		
		public void setWrite(boolean on) {
			write = on;
		}
		
		public void save() {
			set("list", list);
			set("read", read);
			set("write", write);
			set("home", home.booleanValue());
			
			try {
				xml.setOptionValue("alias",alias);
			}catch(NoSuchOptionException nse) {
				xml.addOption("alias",alias);
			}
		}
		
		private void set(String option, boolean on) {
			String value;
			if (on)
				value="yes";
			else
				value="no";	
			
			try {
				xml.setOptionValue(option,value);
			}catch(NoSuchOptionException nse) {
			}
		}
		
		private String get(String option) {
			try {
				return xml.getOptionValue(option).trim();
			}catch(NoSuchOptionException nse) {
				return "";
			}
		}
		
		public boolean getList() {
			return list;
		}
		
		public boolean getRead() {
			return read;
		}
		
		public boolean getWrite() {
			return write;
		}
		
		public XMLTag getTag() {
			return xml;
		}
	}
	
	public class MyMouseListener extends MouseAdapter {
		public void mouseReleased(MouseEvent e) {
			Dir dir = model.getRow(dirsTable.getSelectedRow());
			
			readBox.setSelected(dir.getRead());
			listBox.setSelected(dir.getList());
			writeBox.setSelected(dir.getWrite());
		}
	}
	
	public class DirData extends AbstractTableModel {
  
		private Vector v = new Vector(10);

		int[] size = {170,90,32};
		
		public int getColumnWidth(int i) {
			return size[i];
		}
		
		public int getRowCount() {
			return v.size();
	  }
	  
		public int getColumnCount() {
			return size.length;
	  }
	  
		public Object getValueAt(int row, int column) {
			Dir d = (Dir) v.get(row);
			switch (column){
			
				case 0:
					return d;
				case 1:
					return d.getAlias();
				case 2:
					return d.isHome();
			}
			return "Table column not deffined!";
	  }
		
		public void setValueAt(Object aValue, int rowIndex, int columnIndex)  {
			Dir d = (Dir)v.get(rowIndex);
			
			switch(columnIndex){
				case(1):
					String name=aValue.toString();
					if (System.getProperty("os.name").toLowerCase().startsWith("windows")) {
						if(name.length() > 2 && name.charAt(1) == ':' && name.indexOf('*')==-1 && name.indexOf('?')==-1 && name.indexOf('"')==-1 && name.indexOf('<')==-1 && name.indexOf('>')==-1 && name.indexOf('|')==-1 && name.indexOf(':',2)==-1)
							d.setAlias(new File(aValue.toString()).getAbsolutePath().trim());
						else if (name.equals(""))	
							d.setAlias("");
						else
							JOptionPane.showMessageDialog(null, res.getString("The Filename is not valid!"), res.getString("Notice") ,JOptionPane.WARNING_MESSAGE);							
					}					
					break;
				case(2):
					for (int i = getRowCount()-1 ; i >= 0 ; i--) {
						getRow(i).setHome(new Boolean(false));
					}
					d.setHome((Boolean) aValue);
					break;
			}
		}
		
		public boolean isCellEditable(int rowIndex, int columnIndex) {
			if ( columnIndex == 1 )
				return true;
			return false;	
		}
		
		public void add(Dir d) {
			v.add(d);
			fireTableDataChanged();
		}
		
		public void add(Dir d, int place) {
			v.add(place, d);
			fireTableDataChanged();
		}
		
		public Dir removeRow(int i) {
			Dir d = (Dir)v.remove(i);
			fireTableDataChanged();
			return d;
		}
		
		public void reset() {
			v = new Vector(10);
			fireTableDataChanged();
		}

		public Dir getRow(int i) {
			return (Dir)v.get(i);
		}		
	}
}

