package graphic;

import server.event.*;
import setup.*;
import server.*;
import graphic.services.*;

import java.io.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.*;
import java.text.*;

public class Main extends MemoryFrame implements ServerObserver, ActionListener, CaretListener{

	private SessionObserver se = new SessionObserver();
	private JTextArea view;
	public static Server server;
	private Container c = getContentPane();
	private SmartButton start,stop,find,brugere,list,setup;
	private JScrollBar vs; 
	private JTextField searchField;
	public static HashMap map = new HashMap();
	private UserAdmin userAdmin = new UserAdmin();
	private Setup serverSetup = new Setup();
	private LocaleBox localeBox;

	public Main(Server server, String title, boolean visible) {
		super(title,"JQ-Data FTP Server");
		this.server = server;
		ErrorConsole.instanceOf(); // Errorframe initialiseres
		
		getContentPane().setLayout(new BorderLayout());
		setIconImage(ImageHandler.getImage("stop.gif"));
		addWindowListener(new ApplicationTerminator());
		server.addServerObserver(this);
		
		view = new JTextArea();
		view.setFont(new Font("Courier New",Font.PLAIN,11));
		view.setLineWrap(true);	
		view.setEditable(false);
		view.addCaretListener(this);
		JScrollPane js = new JScrollPane(view);
		vs = js.getVerticalScrollBar();
		js.setVerticalScrollBarPolicy(js.VERTICAL_SCROLLBAR_ALWAYS);
		
		c.add(js,BorderLayout.CENTER);
		c.add(getButton(),BorderLayout.NORTH);

		setSize(540,175);
		restore();
		setVisible(visible);
	}
	
	public JPanel getButton() {
		JPanel j = new JPanel();
		j.setPreferredSize(new Dimension(760,26));//560,26
		GridBagGUI gbg = new GridBagGUI(j);

		start = new SmartButton("start","");
		start.addActionListener(this);
		gbg.insets(2,2,2,0);
		gbg.position(0,0);
		gbg.anchor("W");
		gbg.add(start);
		
		stop =  new SmartButton("stop","");
		stop.addActionListener(this);
		gbg.insets(2,0,2,0);
		gbg.position(1,0);
		gbg.add(stop);
		
		brugere =  new SmartButton("users","");
		brugere.addActionListener(this);
		gbg.insets(2,0,2,0);
		gbg.position(2,0);
		gbg.add(brugere);

		list =  new SmartButton("sessions","");
		list.addActionListener(this);
		gbg.insets(2,0,2,0);
		gbg.position(3,0);
		gbg.add(list);
		
		setup =  new SmartButton("setup","");
		setup.addActionListener(this);
		gbg.insets(2,0,2,0);
		gbg.position(4,0);
		gbg.add(setup);
		
		find =  new SmartButton("magnifying_glass","");
		find.addActionListener(this);
		gbg.insets(2,0,2,0);
		gbg.anchor("E");		
		gbg.position(5,0);
		gbg.weightx(1);
		gbg.add(find);
		
		searchField = new JTextField(10);
		searchField.addActionListener(this);
		gbg.position(6,0);
		gbg.weightx(0);
		gbg.add(searchField);

		localeBox = new LocaleBox();
		localeBox.addActionListener(this);
		localeBox.setSelectedLocale(res.getLocale());
		gbg.insets(2,0,2,15);
		gbg.position(7,0);
		gbg.anchor("W");
		gbg.add(localeBox);

		return j;
	}
	
	public void setText() {
		start.setToolTipText(res.getString("Start the server"));
		stop.setToolTipText(res.getString("Stop the server"));
		brugere.setToolTipText(res.getString("User administration"));
		list.setToolTipText(res.getString("Session list"));
		setup.setToolTipText(res.getString("Server Setup"));
		find.setToolTipText(res.getString("Find a session"));
	}
	
	public class SessionObserver extends UserSessionObserverAdapter {
		public void userLogedIn(UserSession userSession) {
			append(res.getString("Login!  IP:") + " " + userSession.getClientIP() + " ("+userSession.getSessionNr()+") " + res.getString("username") + ":"+userSession.getLogin());
		}
	}
	
	public void caretUpdate(CaretEvent e){
		try {
			int line = view.getLineOfOffset(e.getDot());
			int start= view.getLineStartOffset(line);
			int end  = view.getLineEndOffset(line);
			String t = view.getText(start, end-start-2);
			try {
				searchField.setText(t.substring(t.indexOf('(')+1,t.indexOf(')')));
				searchField.requestFocus();
				searchField.setCaretPosition(searchField.getText().length());
				searchField.requestFocus();
				
			}catch(StringIndexOutOfBoundsException se) {
			}
			
		}catch(BadLocationException ex) {
		}
	}
	
	public void actionPerformed(ActionEvent e) {
		Object source = e.getSource();
		
		if (source == start  && !server.isRunning()) {
			server.start();
		}else if (source == stop && server.isRunning() ) {
			server.stop();
		}else if (source == brugere) {
			userAdmin.setVisible(true);
		}else if(source == list) {
			new UserList("", true);
		}else if (source == setup) {
			serverSetup.setVisible(true);
		}else if(source == localeBox) {
			setMyLocale(localeBox.getSelectedLocale());
			append(res.getString("The language has been set to"));
		}else if(source == find || source == searchField) {
			try {
				int sesnr = Integer.parseInt(searchField.getText());
				Sniffer snif = (Sniffer) map.get(sesnr+"");
				if (snif!=null)
					snif.setVisible(true);
				else {
					LogFileReader[] arr = server.getLogFiles();
					LogFileSession lfs=null;
					for (int i = 0 ; i < arr.length ; i++) {
						lfs = arr[i].getSession(sesnr);
						if (lfs != null) {
							break;
						}							
					}
					if (lfs != null)
						new Sniffer(lfs);	
					else
						JOptionPane.showMessageDialog(this, res.getString("The sessionnumber") + " "+ sesnr + " " + res.getString("has not been found in the history."), res.getString("Notice"), JOptionPane.INFORMATION_MESSAGE); 
				}
			}catch(NumberFormatException nfe) {
				//sg efter brugernavn
			}
		}
	
	}
	
	public void append(String line) {
		String time = new SimpleDateFormat("dd.MM.yy'-'HH:mm:ss").format(new Date()) + "  ";
		view.append(time + line + " \n");
		vs.setValue(vs.getMaximum());
	}
	
	//..........................ServerObserver...............................//
	
	public void clientConnected(UserSession userSession) {
		userSession.addUserSessionObserver(se);
		append(res.getString("Online! IP:") + " " + userSession.getClientIP() + " ("+userSession.getSessionNr()+")");
		
		map.put(""+userSession.getSessionNr(), new Sniffer(userSession));
	}
	
	public void clientDisconnected(UserSession userSession) {
		String login = userSession.getLogin();
		String text;
		if (login.equals(""))
			text = res.getString("Offline!IP:") + " " + userSession.getClientIP() +  " ("+userSession.getSessionNr()+")";
		else
			text = res.getString("Offline!IP:") + " " + userSession.getClientIP() +  " ("+userSession.getSessionNr()+") " + res.getString("username") + ":" + login;		
		
		switch (userSession.getUserState()) {
			case UserSessionObserver.USER_KICKED:
				append(text + " (" + res.getString("Kicked") + "!)");
				break;
			case UserSessionObserver.USER_TIMEOUT:
				append(text + " (" + res.getString("Timout - To low/no activity") + "!)");
				break;
			case UserSessionObserver.USER_BANNED:
				append(text + " (" + res.getString("Banned") + "!)");
				break;
			case UserSessionObserver.USER_AUTO_BANNED:
				append(text + " (" + res.getString("Auto Banned due to recognized pattern") + "!)");
				break;
			case UserSessionObserver.USER_KICKED_DUE_TO_SERVER_STOP:
				append(text + " (" + res.getString("Kicked due to serverstop") + "!)");
				break;	
			default:
				append(text);
		}
		
			
		map.remove(""+userSession.getSessionNr());
	}
	
	public void serverStarted(boolean startedOk) {
		if (startedOk) {
			try {
				append( res.getString("Server started") + ". " + res.getString("IP")+ ": " + java.net.InetAddress.getLocalHost().getHostAddress() + ", " + res.getString("Port") + ": " + server.getServerPort() + "!");
			}catch(java.net.UnknownHostException e) {}
			setIconImage(ImageHandler.getImage("start.gif"));	
		}else
			append(res.getString("Server cannot start") + " " + server.getServerPort() + " " + res.getString("is in use!"));
	}
	
	public void serverStoped() {
		append(res.getString("Server stoped!"));
		setIconImage(ImageHandler.getImage("stop.gif"));	
	}
	
	public class ApplicationTerminator extends WindowAdapter {
    public void windowClosing( WindowEvent e ) {
		
		  // saves the current locale to 'setup.conf'
			try {
	    	Conf.getRoot().setQuickOptionValue("Memory.language",res.getLocale().toString());
	    }catch(NoSuchTagException nste) {
	    	//Will never happen, as the tag is created in memory (if not already present) at program-startup.
	    }
			
			closeAllWindows();
			server.stop();
			Conf.save();
			System.exit(0);
    }
  }
}