package graphic;

import javax.swing.*;
import java.awt.*;
import java.util.*;
import graphic.services.*;

public class Setup extends MemoryFrame{

	private JTabbedPane pane = new JTabbedPane();
	private SetupServer setupServer = new SetupServer(this);
	private SetupBan setupBan = new SetupBan(this);
	private SetupIntelligence setupIntelligence = new SetupIntelligence(this);

	public Setup() {
		super("", "Server Setup");
		setIconImage(ImageHandler.getImage("setup.gif"));
		setDefaultCloseOperation(WindowConstants.HIDE_ON_CLOSE);
		setSize(418,375);
		restore();
		setResizable(false);

		getContentPane().setLayout(new GridLayout(1,1));
		getContentPane().add(pane);
		
		pane.add("Server Setup",setupServer);
		pane.add("Banned IP", setupBan);
		pane.add("Server Intelligence", setupIntelligence);
	}
	
	public void setText() {
		setTitle(res.getString("Server Setup"));
		pane.setTitleAt(0,res.getString("Server Setup"));
		pane.setTitleAt(1,res.getString("Banned IP"));
		pane.setTitleAt(2,res.getString("Server Intelligence"));
		setupServer.setText(res);
		setupBan.setText(res);
		setupIntelligence.setText(res);
	}
	
	public void setVisible(boolean visible) {
		if (visible) {
			setupBan.restore();
			setupServer.restore();
			setupIntelligence.restore();
		}
		super.setVisible(visible);
	}
	
	public void setSelectedComponent(Component comp) {
		pane.setSelectedComponent(comp);
	}
	
	protected void initializeData() {
		setupBan.restore();
		setupServer.restore();
		setupIntelligence.restore();
	}
	
	public void saveInfo() {
		setupBan.save();	
		setupIntelligence.save();
		if (setupServer.save())
			setVisible(false);
	}
	
}