package graphic;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.table.*;
import java.awt.*;
import java.awt.event.*;
import java.util.jar.*;
import java.util.zip.*;
import java.util.*;
import java.io.*;

import server.*;
import setup.*;
import graphic.services.*;

public class SetupIntelligence extends JPanel implements ActionListener, SurvailanceController, Observer{

	private Setup setup;
	private JTable from, to, ban;
	private JLabel kickText,banHead;
	private JScrollPane fromP, toP, banP;
	private CommandTable fromM, toM;
	private BanTable banM;
	private JButton addButton, removeButton, okButton, cancelButton, showBan, deleteBan;
	private JRadioButton enableButton, disableButton;
	private JComboBox hourBox, minBox, secBox;
	private JPanel center;
	private TitledBorder banBorder;
	private String[] activeCommands;
	private Survailance sur = Survailance.instanceOf();
	private ResourceBundle last;
	private Vector deleted = new Vector();

	public SetupIntelligence(Setup setup) {
		this.setup = setup;
		
		sur.addSurvailanceController(this);
		sur.getLogFileReader().addObserver(this);
		
		setLayout(new BorderLayout());
		center = new JPanel();
		GridBagGUI main = new GridBagGUI(center);
		main.position(0,0);
		main.anchor("N");
		main.insets(10,10,0,10);
		main.add(enDis());
		
		main.position(0,1);
		main.fill("B");
		main.anchor("N");
		main.weightx(1);
		main.weighty(1);
		main.size(1,2);
		main.insets(10,10,10,10);
		main.add(autoBan());
		
		JPanel right = new JPanel();
		GridBagGUI rg = new GridBagGUI(right);
		
		rg.position(0,0);
		rg.weightx(1);
		rg.weighty(1);
		rg.fill("B");
		rg.add(getCommandPanel());
		
		rg.position(0,1);
		rg.weighty(0);
		rg.insets(0,0,10,0);
		rg.add(time());
		
		main.position(1,0);
		main.anchor("NE");
		main.weightx(1);
		main.weighty(1);
		main.insets(10,10,0,10);
		main.size(1,3);
		main.add(right);
		
		add(center,BorderLayout.CENTER);
		
		add(bottom(), BorderLayout.SOUTH);
		
		restore();
	}
	
	private JPanel bottom() {
		JPanel panel = new JPanel();
		GridBagGUI gbg = new GridBagGUI(panel);

		okButton = new JButton();
		okButton.addActionListener(this);
		gbg.anchor("E");
		gbg.weightx(1);
		gbg.position(0,0);
		gbg.insets(0,0,5,5);
		gbg.add(okButton);
		
		cancelButton = new JButton();
		cancelButton.addActionListener(this);
		gbg.weightx(0);
		gbg.position(1,0);
		gbg.add(cancelButton);
		
		return panel;
	}
	
	private JPanel autoBan() {
		JPanel panel = new JPanel();
		banBorder = new TitledBorder("");
		panel.setBorder(banBorder);
		GridBagGUI gbg = new GridBagGUI(panel);
		
		banHead = new JLabel();
		gbg.weightx(1);
		gbg.fill("H");
		gbg.position(0,0);
		gbg.size(2,1);
		//gbg.add(banHead);
		
		banM = new BanTable();
		ban = new JTable();
		banP = new JScrollPane(ban);
//		pane.setPreferredSize(new Dimension(130,115));//140
		ban.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		ban.setAutoCreateColumnsFromModel( false );
    ban.setModel( banM );
    ban.getTableHeader().setReorderingAllowed( false );
    
    for (int i = 0 ; i<banM.getColumnCount();i++ )
      ban.addColumn( new TableColumn(i,banM.getSize(i)) );
		
		gbg.weightx(1);
		gbg.weighty(1);
		gbg.fill("B");
		gbg.position(0,1);
		gbg.add(banP);
		
		showBan = new JButton();
		showBan.addActionListener(this);
		gbg.weightx(1);
		gbg.weighty(0);
		gbg.fill("H");
		gbg.insets(10,0,0,10);
		gbg.size(1,1);
		gbg.position(0,2);
		gbg.add(showBan);
		
		deleteBan = new JButton();
		deleteBan.addActionListener(this);
		gbg.insets(10,0,0,0);
		gbg.position(1,2);
		gbg.add(deleteBan);
		
		return panel;
	}
	
	private JPanel time() {
		JPanel panel = new JPanel();
		GridBagGUI gbg = new GridBagGUI(panel);
		
		gbg.position(0,0);
		gbg.insets(0,0,0,7);
		gbg.add(new JLabel("n="));
		
		hourBox = getBox(0,24,TimeInstance.TYPE_HOURS);
		gbg.position(1,0);
		gbg.insets(0,0,0,5);
		gbg.add(hourBox);
		
		minBox = getBox(0,59,TimeInstance.TYPE_MINUTES);
		gbg.position(2,0);
		gbg.add(minBox);
		
		secBox = getBox(0,59,TimeInstance.TYPE_SECONDS);
		gbg.position(3,0);
		gbg.insets(0,0,0,0);
		gbg.add(secBox);
		
		return panel;
	}
	
	private JComboBox getBox(int start, int length, int type) {
		Vector v = new Vector();
		
		for (int i = start ; i <= length ; i++)
			v.add(new TimeInstance(i,type));
		
		return new JComboBox(v);
	}
	
	private JPanel enDis() {
		JPanel panel = new JPanel();
		GridBagGUI gbg = new GridBagGUI(panel);
		
		enableButton = new JRadioButton();
		enableButton.addActionListener(this);
		gbg.position(0,0);
		gbg.add(enableButton);
		
		disableButton = new JRadioButton();
		disableButton.addActionListener(this);
		gbg.position(0,1);
		gbg.add(disableButton);		
		
		ButtonGroup b = new ButtonGroup();
		b.add(enableButton);
		b.add(disableButton);
		
		return panel;
	}
	
	private JPanel getCommandPanel() {
		JPanel com = new JPanel();
		GridBagGUI gbg = new GridBagGUI(com);
		
		kickText = new JLabel();
		kickText.setBackground(new Color(255,255,255));
		gbg.setFont("Times New Roman", 0, 12);
		gbg.position(0,0);
		gbg.size(3,1);
		gbg.weightx(1);
		gbg.fill("H");
		gbg.insets(0,0,10,0);
		gbg.add(kickText);
		
		from  = new JTable();
		from.getTableHeader().setReorderingAllowed(false);
		from.getTableHeader().setResizingAllowed(false);
		fromP = new JScrollPane(from);
		gbg.position(0,1);
		gbg.size(1,2);
		gbg.weighty(1);	
		gbg.weightx(1);
		gbg.fill("B");
		gbg.add(fromP);		
		
		to  = new JTable();
		to.getTableHeader().setReorderingAllowed(false);
		to.getTableHeader().setResizingAllowed(false); 
		toP = new JScrollPane(to);
		gbg.position(2,1);
		gbg.add(toP);
		
		addButton = new JButton(">");
		addButton.addActionListener(this);
		gbg.position(1,1);
		gbg.size(1,1);
		gbg.fill("N");
		gbg.anchor("S");
		gbg.weighty(1);
		gbg.weightx(0);
		gbg.insets(0,0,0,0);
		gbg.add(addButton);
		
		removeButton = new JButton("<");
		removeButton.addActionListener(this);
		gbg.anchor("N");
		gbg.position(1,2);
		gbg.add(removeButton);
		
		return com;
	}
	
	private void setActive(boolean active) {
		
		if (active) {
			fromP.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
			from.setBackground(new Color(255,255,255,255));
			toP.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
			to.setBackground(new Color(255,255,255,255));
			banP.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
			ban.setBackground(new Color(255,255,255,255));
		}else {
			fromP.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_NEVER);
			from.setBackground(new Color(0,0,0,0));
			toP.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_NEVER);
			to.setBackground(new Color(0,0,0,0));
			banP.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_NEVER);
			ban.setBackground(new Color(0,0,0,0));
		}
		hourBox.setEnabled(active);
		minBox.setEnabled(active);
		secBox.setEnabled(active);
		addButton.setEnabled(active);
		removeButton.setEnabled(active);
		from.setEnabled(active);
		to.setEnabled(active);
		ban.setEnabled(active);
		showBan.setEnabled(active);
		deleteBan.setEnabled(active);
	}
	
	public void setText(ResourceBundle res) {
		last=res;
		to.getColumnModel().getColumn(0).setHeaderValue(res.getString("Active"));
		from.getColumnModel().getColumn(0).setHeaderValue(res.getString("Passive"));
		ban.getColumnModel().getColumn(0).setHeaderValue(res.getString("Ses"));
		ban.getColumnModel().getColumn(1).setHeaderValue(res.getString("IP"));
		okButton.setText(res.getString("Save"));
		cancelButton.setText(res.getString("Abort"));
		kickText.setText(res.getString("<html>After 'n' time, any client will be kicked, if he does not invoke an 'Active' command. <br><i>Note that no one is kicked within their first 10 seconds</i></html>"));
		disableButton.setText(res.getString("Disable intelligence"));
		enableButton.setText(res.getString("Enable intelligence"));
		banBorder.setTitle(res.getString("AutoBan Patterns"));
		showBan.setText(res.getString("Show"));
		deleteBan.setText(res.getString("Delete"));
		TimeInstance.res = res;
	}
	
	private String getFormattedComboBoxValue(JComboBox combo) {
		int i = ((TimeInstance)combo.getSelectedItem()).getTime();
		
		if (i>=10)
			return ""+i;
		else
			return "0"+i;
	}
	
	private void setComboBox(int i, JComboBox box) {
		int size = box.getItemCount();
		TimeInstance time;
		for (int j = 0 ; i < size ; j++) {
			time = (TimeInstance) box.getItemAt(j);
			if (time.getTime() == i) {
				box.setSelectedIndex(j);
				break;
			}
		}
	}
	
	private Vector fillAllCommandsInVector() {
    String name1 = "/" + this.getClass().getName().replace('.', '/') + ".class";
    String jar = this.getClass().getResource(name1).getFile();
		Vector v = new Vector();
		String[] list;
		File f = new File("server" + System.getProperty("file.separator") + "commands" );
		if (f.exists())
			list = f.list();
		else {
			Vector tmp = new Vector();
			try {
				JarFile jf = new JarFile(ImageHandler.convertWhiteSpace(jar.substring(jar.lastIndexOf(":") + 1, jar.lastIndexOf("!"))));
				
				Enumeration enu = jf.entries();
				while (enu.hasMoreElements()) {
					ZipEntry e = (ZipEntry) enu.nextElement();
					if (e.getName().startsWith("server/commands") && !e.isDirectory()) {
						tmp.add(new String(e.getName().substring(16)));
					}
				}
			}catch(IOException e) {
        e.printStackTrace();
				//Cannot read Jar-file. List will be empty...
			}
			
			list = new String[tmp.size()];
			for (int i = 0 ; i < list.length ; i++)
				list[i] = tmp.get(i).toString();
		}	
		
		
		String name;
		for (int i = 0 ; i < list.length ; i++) {
			if (list[i].endsWith(".class"))
				try{
					name = "server.commands."+list[i].substring(0,list[i].length()-6);
					if (Class.forName(name).getSuperclass().getName().equals("server.commands.AbstractCommand") &&
							!name.equals("server.commands.Welcome") && //This special command is not optional
							!name.equals("server.commands.Unknown") && //This special command is not optional
							!name.equals("server.commands.NotLogedIn") //This special command is not optional						
					)
						v.add(name.substring(16,name.length()));
							
				}catch(Exception e) {
					System.out.println(e);
				}
		}
		return v;
	}

	public void actionPerformed(ActionEvent e) {
		Object source = e.getSource();
		
		if (source == addButton) {
			int[] rows = from.getSelectedRows();
			for (int i = rows.length-1; i >= 0 ; i--) {
				toM.add(fromM.remove(rows[i]));	
			}
		}else if(source == removeButton) {
			int[] rows = to.getSelectedRows();
			for (int i = rows.length-1; i >= 0 ; i--) {
				fromM.add(toM.remove(rows[i]));	
			}
		}else if(source == okButton) {
			setup.saveInfo();
		}else if(source == cancelButton) {
			setup.setVisible(false);
		}else if(source == disableButton) {
			setActive(false);
		}else if(source == enableButton) {
			setActive(true);
		}else if(source == showBan) {
			int row = ban.getSelectedRow();
			if (row >= 0)
				new Sniffer(banM.getLogFileSessionInRow(row));
		}else if(source == deleteBan) {
			int i = JOptionPane.showConfirmDialog(null, last.getString("Are you shure you wish to delete this pattern?"), last.getString("Shure?"), JOptionPane.YES_NO_OPTION);
			if (i == 0)  {
				int row = ban.getSelectedRow();
				if (row >= 0)
					banM.remove(ban.getSelectedRow());
			}	
		}
	}
	
	public void restore() {
		fromM = new CommandTable(fillAllCommandsInVector());
		from.setModel(fromM);
		
		toM = new CommandTable(new Vector());
		to.setModel(toM);
		
		activeCommands = Conf.getActiveCommands();
		for (int i = activeCommands.length-1 ; i >= 0 ; i--) {
			toM.add(fromM.remove(activeCommands[i]));
		}
		
		if (last != null)
			setText(last);
		
		if (Conf.IsIntelligenceActive())
			enableButton.doClick();
		else
			disableButton.doClick();
		
		StringTokenizer st = new StringTokenizer(Conf.getCheckIniterval(),":");
		try {
			setComboBox(Integer.parseInt(st.nextToken()),hourBox);
			setComboBox(Integer.parseInt(st.nextToken()),minBox);
			setComboBox(Integer.parseInt(st.nextToken()),secBox);
		}catch(NumberFormatException nfe) {
		}catch(NoSuchElementException nsee) {
		}
		
		int time = ((TimeInstance)hourBox.getSelectedItem()).getTime()*60^2+((TimeInstance)minBox.getSelectedItem()).getTime()*60+((TimeInstance)secBox.getSelectedItem()).getTime();
		sur.setSecondsToTimeout(time);		
		
		for (int i = 0 ; i < deleted.size() ; i ++)
				banM.add((LogFileSession)deleted.get(i));
		deleted.clear();	
	}
	
	public void save() {
		if (enableButton.isSelected())
			sur.start();
		else
			sur.stop();	
	
		int i = toM.getRowCount();
		String[] all = new String[i--];
		while (i >= 0) {
			all[i] = toM.getValueAt(i,0).toString();
			i--;
		}
		activeCommands = all;
		Conf.setActiveCommands(all);
		Conf.setIntelligenceActive(sur.isStarted());
		Conf.setCheckIniterval(getFormattedComboBoxValue(hourBox) + ":" + getFormattedComboBoxValue(minBox) + ":" + getFormattedComboBoxValue(secBox));	
		int time = ((TimeInstance)hourBox.getSelectedItem()).getTime()*60^2+((TimeInstance)minBox.getSelectedItem()).getTime()*60+((TimeInstance)secBox.getSelectedItem()).getTime();
		sur.setSecondsToTimeout(time);
		deleted.clear();
	}
	
	public boolean letSessionContinue(String command, UserSession us) {

		for ( int i = activeCommands.length-1 ; i >= 0 ; i--)
			if ( command.toLowerCase().startsWith(activeCommands[i].toLowerCase()) )
				return true;

		return false;
	}
	
	public boolean disconnectSession(String command, UserSession us) {
		return false;
	}
	
	public void update(Observable obs, Object obj) {
		banM.fireTableDataChanged();
	}
	
	class BanTable extends AbstractTableModel {
		
		private Survailance sur = Survailance.instanceOf();
		private int[] size = {30,100};
		
		public int getSize(int i) {
			return size[i];
		}
		
		public void add(LogFileSession ses) {
			sur.addKickPattern(ses);
		}
		
		public boolean remove(int row) {
			LogFileSession ses = getLogFileSessionInRow(row);
			deleted.add(ses);
			if (ses != null)
				return sur.deleteKickPattern(ses);
			else
				return false;
		}
	
		public Object getValueAt(int row,int column) {
			int[] sesnr = sur.getLogFileReader().getSessionNumbers();
			LogFileSession session = sur.getLogFileReader().getSession(sesnr[row]);
			switch (column) {
				case 0:
					return ""+session.getSessionNr();
				case 1:
					return session.getClientIP();
			}
			return null;
		}
		
		public LogFileSession getLogFileSessionInRow(int row) {
			int i = Integer.parseInt(getValueAt(row,0).toString());
			return sur.getLogFileReader().getSession(i);
		}
		
		public int getColumnCount() {
			return 2;
		}
		
		public int getRowCount() {
			int[] arr = sur.getLogFileReader().getSessionNumbers();
			if (arr == null)
				return 0;
			else	
				return arr.length;
		}
	}
	
	class CommandTable extends AbstractTableModel {
	
		private String sep = System.getProperty("file.separator");
		private Vector contens;
		
		public CommandTable(Vector contens) {
			this.contens = contens;
		}
		
		public void add(Object row) {
			contens.add(row);
			contens = new Vector(new TreeSet(contens));
			fireTableDataChanged();
		}
		
		public Object remove(int row) {
			Object tmp = contens.remove(row);
			fireTableDataChanged();
			return tmp;
		}
		
		public Object remove(String command) {
			for (int i = contens.size()-1 ; i >= 0 ; i--)
				if (contens.get(i).toString().equalsIgnoreCase(command)) {
					return contens.remove(i);
				}
			return null;
		}
	
		public Object getValueAt(int row,int column) {
			return contens.get(row);
		}
		
		public int getColumnCount() {
			return 1;
		}
		
		public int getRowCount() {
			return contens.size();
		}
	}
}
