package graphic;

import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

import server.*;
import setup.*;
import graphic.services.*;

public class SetupServer extends JPanel implements ActionListener{

	private GridBagGUI gbg = new GridBagGUI(this);
	private JLabel ipBesk, userBesk, ipLabel, portLabel, pasvLabel, capacityLabel, maxUsersLabel, loginsLabel, uploadLabel, downloadLabel, bounceLabel, logLabel, kbLabel;
	private JTextField ipField, portField, pasvFieldStart, pasvFieldSlut, capacityField, maxUsersField;
	private JButton save, restore;
	private CountField loginCount, uploadCount, downloadCount;
	private JCheckBox bounceBox, logBox;
	private Setup setup;
	private JPanel usersPanel;

	public SetupServer(Setup setup) {
		this.setup = setup;
		ipBesk = new JLabel();
		gbg.setFont("Times New Roman", 0, 12);
		gbg.insets(5,5,0,5);
		gbg.position(0,0);
		gbg.anchor("NW");
		gbg.size(6,1);
		gbg.add(ipBesk);
		
		ipLabel = new JLabel();
		gbg.setFont("Times New Roman", 0, 14);
		gbg.size(1,1);
		gbg.position(0,1);
		gbg.add(ipLabel);
		
		ipField = new JTextField(10);
		gbg.position(1,1);
		gbg.add(ipField);
		
		portLabel = new JLabel();
		gbg.position(2,1);
		gbg.add(portLabel);
		
		portField = new JTextField(4);
		gbg.position(3,1);
		gbg.add(portField);
		
		pasvLabel = new JLabel();
		gbg.position(0,2);
		gbg.add(pasvLabel);
		
		pasvFieldStart = new JTextField(4);
		pasvFieldSlut = new JTextField(4);
		JPanel pasv = new JPanel();
		GridBagGUI pgbg = new GridBagGUI(pasv);
		pgbg.position(0,0);
		pgbg.add(pasvFieldStart);
		pgbg.position(1,0);
		pgbg.add(new JLabel("-"));
		pgbg.position(2,0);
		pgbg.add(pasvFieldSlut);
		gbg.position(1,2);
		gbg.add(pasv);
		
		capacityLabel = new JLabel();
		gbg.position(0,3);
		gbg.add(capacityLabel);
		
		JPanel kbp = new JPanel();
		GridBagGUI lgbg = new GridBagGUI(kbp);
		capacityField = new JTextField(4);
		lgbg.position(0,0);
		lgbg.add(capacityField);
		
		lgbg.position(1,0);
		kbLabel = new JLabel();
		lgbg.add(kbLabel);
		
		gbg.position(1,3);
		gbg.add(kbp);
		
		maxUsersLabel = new JLabel();
		gbg.position(0,4);
		gbg.add(maxUsersLabel);
		
		maxUsersField = new JTextField(3);
		gbg.position(1,4);
		gbg.add(maxUsersField);
		
		usersPanel = new JPanel();
		usersPanel.setBorder(new TitledBorder(""));
		GridBagGUI ugbg = new GridBagGUI(usersPanel);
		gbg.size(4,1);
		gbg.fill('B');
		gbg.weightx(1);
		gbg.weighty(1);
		gbg.position(0,5);
		gbg.insets(5,5,5,5);
		gbg.add(usersPanel);
		
		//Max Logins
		
		loginsLabel = new JLabel();
		ugbg.anchor("NW");
		ugbg.position(0,0);
		ugbg.insets(3,2,0,0);
		ugbg.add(loginsLabel);
		
		loginCount = new CountField();
		ugbg.position(1,0);
		ugbg.add(loginCount);
		//Max upload
		
		uploadLabel = new JLabel();
		ugbg.position(0,1);
		ugbg.add(uploadLabel);
		
		uploadCount = new CountField();
		ugbg.position(1,1);
		ugbg.add(uploadCount);
		//Max Download
		
		downloadLabel = new JLabel();
		ugbg.position(0,2);
		ugbg.insets(3,2,0,0);
		ugbg.add(downloadLabel);
		
		downloadCount = new CountField();
		ugbg.position(1,2);
		ugbg.add(downloadCount);
		// bounce attack
		
		bounceLabel = new JLabel();
		ugbg.position(0,3);
		ugbg.add(bounceLabel);
		
		bounceBox = new JCheckBox();
		ugbg.position(1,3);
		ugbg.add(bounceBox);
		
		// log
		
		logLabel = new JLabel();
		ugbg.position(0,4);
		ugbg.add(logLabel);
		
		logBox = new JCheckBox();
		ugbg.position(1,4);
		ugbg.add(logBox);
		
		//beskrivelse
		
		userBesk = new JLabel();
		ugbg.anchor("N");
		ugbg.insets(0,25,2,2);
		ugbg.setFont("Times New Roman", 0, 12);
		ugbg.position(3,0);
		ugbg.size(2,4);
		ugbg.add(userBesk);
		
		save = new JButton();
		save.addActionListener(this);
		ugbg.anchor("E");
		ugbg.insets(2,2,2,2);
		ugbg.fill("N");
		ugbg.weightx(1);
		ugbg.size(1,1);
		ugbg.position(3,4);
		ugbg.add(save);
		
		restore = new JButton();
		restore.addActionListener(this);
		ugbg.weightx(0);
		ugbg.fill("N");
		ugbg.weightx(0);
		ugbg.position(4,4);
		ugbg.add(restore);
		
		restore();
	}
	
	public void setText(ResourceBundle res) {
		//.setText(res.getString(""));
			ipBesk.setText(res.getString("<html>Here it is stated what IP the server should run on. The IP is used for <br>the servers 'Passiv IP'. If this box is empty, the server uses the hosts own IP.</html>"));
			ipLabel.setText(res.getString("IP"));
			portLabel.setText(res.getString("Port"));
			pasvLabel.setText(res.getString("Passiv ports"));
			capacityLabel.setText(res.getString("Linecapacity"));
			kbLabel.setText(res.getString("KB"));;
			maxUsersLabel.setText(res.getString("Max Users"));
			usersPanel.setBorder(new TitledBorder("Standard settings for all users")); //Resource string needed!!!!
			logBox.setName((res.getString("Log")));
			bounceLabel.setText(res.getString("Allow Bounce"));
			loginsLabel.setText(res.getString("Max Logins"));
			loginsLabel.setToolTipText(res.getString("Number of logins of a certain user on one ip adress"));
			uploadLabel.setText(res.getString("Max Upload KB"));
			uploadLabel.setToolTipText(res.getString("The number of KB that the client may send to the server pr. second."));
			downloadLabel.setText(res.getString("Max Download KB"));
			downloadLabel.setToolTipText(res.getString("The number of KB that the client may recive from the server pr. second."));
			logLabel.setText(res.getString("Log"));
			logBox.setName((res.getString("Log")));
			bounceLabel.setText(res.getString("Allow Bounce"));
			bounceBox.setName(res.getString("Allow Bounce Attack"));
			userBesk.setText(res.getString("<html>This setup has effect on<br>users that has no specific setup<br>defined for themselves<br><br>Up- and Download are infinite <br>by the value of '-1'</html>")); 
			save.setText(res.getString("Save")); 
			restore.setText(res.getString("Abort")); 
	}
	
	public void restore() {
		ipField.setText(getValue("ip"));
		portField.setText(getValue("port"));
		pasvFieldStart.setText(getPasv(0));
		pasvFieldSlut.setText(getPasv(1));
		capacityField.setText(getValue("linecapacity"));
		maxUsersField.setText(getValue("max_total_users"));
		loginCount.field.setText(getValue("max_logins_per_user"));
		uploadCount.field.setText(getValue("max_client_upload"));
		downloadCount.field.setText(getValue("max_client_download"));
		bounceBox.setSelected(getBoolean("allow_bounce_attack"));
		logBox.setSelected(getBoolean("log"));
	}
	
	private void say(String comment) {
		JOptionPane.showMessageDialog(this, comment, "Advarsel!" ,JOptionPane.WARNING_MESSAGE); 
	}
	
	private boolean isNum(JTextField field, JLabel fieldLabel,int min, int max) {
		try {
			int i = Integer.parseInt(field.getText());
			field.setText(""+i);
			if (i >= min && i <= max)
				return true;
			else {
				JOptionPane.showMessageDialog(this, "Feltet ["+fieldLabel.getText()+"] SKAL indeholde et tal mellem " + min + " og " + max + "!", "Advarsel!" ,JOptionPane.WARNING_MESSAGE); 
				return false;
			}
		}catch(NumberFormatException nfe) {
			JOptionPane.showMessageDialog(this, "Feltet ["+fieldLabel.getText()+"] SKAL indeholde et tal! ", "Advarsel!" ,JOptionPane.WARNING_MESSAGE); 
			return false;
		}
	}
	
	public boolean save() {
		setup.setSelectedComponent(this);
		String tmp;
		
		//Valider IP adressen
		tmp = ipField.getText();
		StringTokenizer st = new StringTokenizer(tmp,".");
		if (tmp.length() != 0 && st.countTokens() != 4) {
			say("IP adressen ["+tmp+"] er ikke valid!");
			return false;
		}
		int tal;
		String token;
		for (int i = 0 ; st.hasMoreTokens() ; i++ ) {
			token = st.nextToken();
			try {
				tal = Integer.parseInt(token);
				if (!(tal <= 255 && tal >= 0) || token.length() > 3) {
					say("IP adressen ["+tmp+"] er ikke valid. Alle tal skal vre mellem 0 og 255! Fejlen var: ["+token+"].");
					return false;
				}
			}catch(NumberFormatException nfe) {
				say("IP adressen ["+tmp+"] er ikke valid! Fejlen var: ["+token+"].");
				return false;
			}
		}
		
		if(isNum(portField, portLabel,0,65536) == false)
			return false;
		if(isNum(pasvFieldStart, pasvLabel,0,65536) == false)
			return false;
		if(isNum(pasvFieldSlut, pasvLabel,0,65536) == false)
			return false;
		if(isNum(capacityField, capacityLabel,1,99999999) == false)
			return false;
		if(isNum(maxUsersField, maxUsersLabel,0,99999999) == false)
			return false;
		if(isNum(loginCount.field, loginsLabel,0,99999999) == false)
			return false;	
		if(isNum(uploadCount.field, uploadLabel,-1,99999999) == false)
			return false;
		if(isNum(downloadCount.field, downloadLabel,-1,99999999) == false)
			return false;	
		
		setValue("ip",ipField.getText());
		setValue("port",portField.getText());
		setValue("passivports",pasvFieldStart.getText() + "-" + pasvFieldSlut.getText());
		setValue("linecapacity",capacityField.getText());
		setValue("max_total_users",maxUsersField.getText());
		setValue("max_logins_per_user",loginCount.field.getText());
		setValue("max_client_upload",uploadCount.field.getText());
		setValue("max_client_download",downloadCount.field.getText());
		setBool("log", logBox.isSelected());
		setBool("allow_bounce_attack", bounceBox.isSelected());

		return true;
	}
	
	private void setBool(String option, boolean on) {
		String ok;
		if (on)
			ok="yes";
		else
			ok="no";	
		
		setValue(option,ok);
	}
	
	public void setValue(String option, String value) {
		try {
			Conf.getRoot().setQuickOptionValue("Server."+option, value);
		}catch(NoSuchTagException nse) {
			Conf.getRoot().addOption("Server."+option, value);
		}
	}
	
	private JButton getButton(String name, String toolTipTekst) {
		JButton j = new JButton();		
		ImageIcon im = new ImageIcon("image/" + name + ".gif");
		j.setToolTipText(toolTipTekst);
		j.setIcon(im);
		j.setPreferredSize(new Dimension(im.getIconWidth(), im.getIconHeight()));
		j.setBorder(new EmptyBorder(0,0,0,0));
		j.addActionListener(this);
		return j;
	}
	
	private String getPasv(int nr) {
		String pasv = getValue("passivports");
		
		if(nr==0) 
			return pasv.substring(0,pasv.indexOf("-"));
		else	
			return pasv.substring(pasv.indexOf("-")+1,pasv.length());
	}
	
	private String getValue(String name) {
		try {
			return Conf.getRoot().getQuickOptionValue("Server."+name);
		}catch(NoSuchTagException nste) {
			return "";
		}
	}
	
	private boolean getBoolean(String name) {
		return getValue(name).equals("yes");
	}
	
	private boolean isNum(String num) {
		try {
			Integer.parseInt(num);
			return true;
		}catch(NumberFormatException nfe) {
			return false;
		}
	}
	
	public void actionPerformed(ActionEvent e) {
		Object source = e.getSource();
		
		if(source == restore) {
			setup.setVisible(false);
		}else if(source == save) {
			setup.saveInfo();
		}
	}
	
}