package graphic;

import java.awt.event.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
import java.net.*;
import java.io.*;
import java.util.*;
import java.text.*;

import server.event.*;
import server.*;
import graphic.services.*;

public class Sniffer extends MemoryFrame implements ActionListener, UserSessionObserver, ChangeListener {
	
	private Container c = getContentPane();
	private GridBagGUI gbg = new GridBagGUI(c);
	private JTextArea area;
	private JTextField input,sesnr,ip,tid,user;
	private JLabel sesnrL,ipL,tidL,userL,upDown,minMax;
	private UserSession ses;
	private LogFileSession logFileSession;
	private JScrollBar vs;
	private JScrollPane js;
	private JPanel filePanel;
	private JProgressBar fileProgress, speedProgress;
	private JSlider speedSlider;
	private boolean transfering = false;
	private int transfered=0;
	private long speedHelp=0;
	private long speedMemory=0;
	private int turboMemory=0;
	private long time;
	private JButton stop,kick,ban,autobanPattern;
	private JToggleButton turbo;
	private boolean ended=true;

	private Sniffer() {
		super("","Sniffer");
		setIconImage(ImageHandler.getImage("magnifying_glass.gif"));
		setDefaultCloseOperation(WindowConstants.HIDE_ON_CLOSE);
		setSize(590,400);
		
		restore();
		area = new JTextArea();
		area.setEditable(false);
		js = new JScrollPane(area);
		vs = js.getVerticalScrollBar();
		
		JPanel jp = new JPanel();
//		jp.setBorder(new TitledBorder("abc"));
		GridBagGUI g = new GridBagGUI(jp);
		g.insets(5,5,1,5);
		g.size(1,1);
		g.fill('N');
		g.anchor("W");
		
		userL = new JLabel();
		g.position(0,0);
		g.add(userL);
		
		user = new JTextField(10);
		user.setEnabled(false);
		g.position(1,0);
		g.add(user);
		
		sesnrL = new JLabel();
		g.position(2,0);
		g.add(sesnrL);
		
		sesnr = new JTextField(3);
		sesnr.setEnabled(false);
		g.position(3,0);
		g.add(sesnr);
		
		ipL = new JLabel();
		g.position(0,1);
		g.insets(1,5,1,5);
		g.add(ipL);

		tidL = new JLabel();
		g.position(0,2);
		
		g.add(tidL);
		g.insets(0,5,5,5);
		g.size(3,1);
		
		ip = new JTextField(18);
		ip.setEnabled(false);
		g.position(1,1);
		g.insets(1,5,1,5);
		g.add(ip);

		tid = new JTextField(18);
		tid.setEnabled(false);
		g.position(1,2);
		g.insets(0,5,5,5);
		g.add(tid);
		
		filePanel = new JPanel();
		g.position(4,0);
		g.size(1,3);
		g.weightx(1);
		g.fill('B');
		g.add(filePanel);
		
		gbg.position(0,0);
		gbg.anchor("NW");
		gbg.weightx(1);
		gbg.fill('H');
		gbg.add(jp);
	}
		
	public Sniffer(UserSession ses) {
		this();
		
		sesnr.setText(""+ses.getSessionNr());
		ip.setText(ses.getClientIP());
		tid.setText(new SimpleDateFormat("'D.' dd.MM.yyyy ' kl.' HH:mm:ss").format(new Date()));
		
		this.ses = ses;
		ses.addUserSessionObserver(this);
		
		JPanel c = new JPanel();
		c.setLayout(new BorderLayout());		
		c.add(js ,BorderLayout.CENTER);
		input = new JTextField();
		input.addActionListener(this);
		c.add(input,BorderLayout.SOUTH);
		
		gbg.position(0,1);
		gbg.fill('B');
		gbg.weighty(1);
		gbg.weightx(1);
		gbg.add(c);
		
		//FilePanel setup
		
		GridBagGUI fp = new GridBagGUI(filePanel);
		
		fp.position(0,0);
		upDown = new JLabel();
		fp.add(upDown);
		
		fileProgress = new JProgressBar();
		fileProgress.setPreferredSize(new Dimension(100,10));
		fp.position(0,1);
		fp.add(fileProgress);
		
		fp.position(0,2);
		minMax  = new JLabel("Min             Max");
		fp.add(minMax);
		
		speedSlider = new JSlider();
		speedSlider.setPreferredSize(new Dimension(114,15));
		speedSlider.addChangeListener(this);
		speedSlider.setValue(0);
		fp.position(0,3);
		fp.add(speedSlider);
		
		speedProgress = new JProgressBar();
		speedProgress.setString("");
		speedProgress.setStringPainted(true);
		speedProgress.setPreferredSize(new Dimension(100,18));
		fp.position(0,4);
		fp.add(speedProgress);
		
		JPanel p = new JPanel();
		p.setLayout(new GridLayout(2,2,2,10));
		
		kick = new JButton();
		kick.addActionListener(this);
		p.add(kick);
		
		ban = new JButton();
		ban.addActionListener(this);
		p.add(ban);
		
		turbo = new JToggleButton();
		turbo.addActionListener(this);
		p.add(turbo);
		
		stop = new JButton();
		stop.addActionListener(this);
		p.add(stop);
		
		fp.position(1,0);
		fp.anchor("S");
		fp.size(1,5);
		fp.add(p);	
		setText();
	}
	
	public void setText() {
		if (ses == null) {
			setTitle(res.getString("History session... username:") + " " + logFileSession.getLogin());		
			autobanPattern.setText(res.getString("Use as 'AutoBan' Pattern"));
		}else{
			if (ses.isLogedIn() || (ended && !user.getText().equals("")))
				setTitle(res.getString("Online session... username:") + " " + ses.getLogin());
			else	
				setTitle(res.getString("Online session... user has not loged in."));
		}
		//.setText(res.getString(""));		
		userL.setText(res.getString("Username") + ":");
		sesnrL.setText(res.getString("Sesnr") + ":");
		ipL.setText(res.getString("IP") + ":");
		tidL.setText(res.getString("Time") + ":");
		ban.setText(res.getString("Ban")+"!");
		
		if (upDown != null) {
			upDown.setText(res.getString("Percent up/down") + ":");
			kick.setText(res.getString("Kick")+"!");
			turbo.setText(res.getString("Turbo")+"!");
			stop.setText(res.getString("Stop")+"!");
			
			if (transfering) {
				fileProgress.setToolTipText(res.getString("Filetransfer started"));
				if (ses.isFileUpload())
					upDown.setText(res.getString("Percent upload"));
				else
					upDown.setText(res.getString("Percent download"));
			}else {
				upDown.setText("");
				if (fileProgress.getValue() == fileProgress.getMaximum()) {
					fileProgress.setToolTipText(res.getString("The file has been transfered"));
				}else {
					fileProgress.setToolTipText(res.getString("The filetransfer was aborted"));
				}
			}
		}		
	}
	
	private int getMax(String max) {
		String res = Conf.getUserOption(ses.getClientTag(), max);
		try {
			return Integer.parseInt(res);
		}catch(NumberFormatException nf) {
			//bb.commandException(nf,"Der er fejl i XML-filen setup.conf. Et tal var forventet ved "+ max +" tagget. Fandt istedet:["+res+"]. Bruger ubegrnset hastighed.");
			return -1;
		}
	}
	
	public void setVisible(boolean visible) {
		super.setVisible(visible);
		if (visible)
			area.setCaretPosition(area.getText().length()-1);
	}
	
	public Sniffer(LogFileSession logfile) {
		this();
		this.logFileSession = logfile;
		sesnr.setText(""+logfile.getSessionNr());
		ip.setText(logfile.getClientIP());
		user.setText(logfile.getLogin());
		tid.setText(logfile.getLogonTime());
		

		GridBagGUI fp = new GridBagGUI(filePanel);
		
		ban = new JButton();
		ban.addActionListener(this);
		fp.position(0,0);
		fp.anchor("NW");
		fp.insets(5,5,5,5);
		fp.weighty(1);
		fp.add(ban);
		
		autobanPattern = new JButton();
		autobanPattern.addActionListener(this);
		fp.position(1,0);
		fp.weightx(1);
		fp.add(autobanPattern);
				
		gbg.position(0,1);
		gbg.fill('B');
		gbg.weighty(1);
		gbg.weightx(1);
//	  area.setSize(new Dimension(400,350));
		gbg.add(js);
		
		
		Vector v = logfile.getConversation();
		int size= v.size();
		for(int i = 0 ; i < size; i++)
			addText(v.get(i).toString().substring(2));
		setText();
		setVisible(true);
	}
	
	public void addText( String txt ){
		area.append(txt + "\n");
		area.setCaretPosition(area.getText().length());
	}
	
	public void stateChanged(ChangeEvent e) {
		ses.setSpeedInBytesPrSek(speedSlider.getValue());
	}
	
	public void actionPerformed(ActionEvent e) {
		Object source = e.getSource();
		
		if (source == input) {
			ses.tellClient("200 " + input.getText());
			input.setText("");
		}else if (source == kick) {
			ses.disconnectClient(UserSessionObserver.USER_KICKED);
			forceEnd();
		}else if (source == ban) {
			InetAddress ip=null;
			if (ses != null) {//Online Session
				ip = ses.getClientInetAddress();
				Conf.banAddress(ip);
				ses.disconnectClient(UserSessionObserver.USER_BANNED);
			}else//Logfile Session
				try {
					ip = InetAddress.getByName(logFileSession.getClientIP());
					Conf.banAddress(ip);
				}catch(UnknownHostException uhe) {
					//could not ban
				}
			JOptionPane.showMessageDialog(null, res.getString("The IP address has been banned") + "\n"+res.getString("IP")+": (" + ip.getHostAddress() + ")", res.getString("Notice"), JOptionPane.INFORMATION_MESSAGE	);	
			forceEnd();
		}else if (source == turbo) {
			if (turbo.isSelected()) {
				turboMemory = speedSlider.getValue();
				ses.setSpeedInBytesPrSek(-1);
			}else {
				speedSlider.setValue(turboMemory);
				ses.setSpeedInBytesPrSek(turboMemory);
				speedMemory = turboMemory;
			}
		}else if (source == stop) {
			ses.abortTransmission();
		}else if (source == autobanPattern) {
			Survailance sur = Survailance.instanceOf();
			int sesnr= sur.addKickPattern(logFileSession);
			if (sesnr == -1)
				JOptionPane.showMessageDialog(null, res.getString("The pattern has been added."), res.getString("Notice") ,JOptionPane.INFORMATION_MESSAGE); 
			else
				JOptionPane.showMessageDialog(null, res.getString("The pattern already exists. No action was taken.") + " " + res.getString("Session") + " " + sesnr + " " + res.getString("in the AutoBan list."), res.getString("Notice") ,JOptionPane.INFORMATION_MESSAGE); 	
		}
	}
	
	public void commandUpdate(String command) {
		if (command.startsWith("PASS")) {
			String temp = "PASS ";
			for (int i = 0; i < command.length() - 5; i++) {
				temp += "*";
			}
			command = temp;
		}
		addText(command);
	}
	
	public void serverResponse(String response) {
		addText(response);
	}	
	
  public void fileTransferStarted(File file) {
  	time = new Date().getTime();
		fileProgress.setMaximum(new Long(file.length()).intValue());
		fileProgress.setForeground(new Color(0,0,255,255));
		fileProgress.setToolTipText(res.getString("Filetransfer started"));
		int max=0;
		
		if (speedMemory != 0) {
			max = (int)speedMemory;
			//ses.setSpeedInBytesPrSek(max);
		}else if (ses.isFileUpload()) {
			upDown.setText(res.getString("Percent upload"));
			try {max=Integer.parseInt(Conf.getUserOption(ses.getClientTag(), "max_client_download"))*1024;}catch(NumberFormatException nfe) {}
		}else {
			upDown.setText(res.getString("Percent download"));
			try {max=Integer.parseInt(Conf.getUserOption(ses.getClientTag(), "max_client_upload"))*1024;}catch(NumberFormatException nfe) {}
		}
		int capacity = Conf.getLineCapacity()*1024;
		speedProgress.setForeground(new Color(0,0,255,255));
		speedProgress.setMaximum(capacity);
		speedSlider.setMaximum(capacity);
		speedSlider.setValue(max);
		
		ses.setSpeedInBytesPrSek(max);
  }	

	public void fileTransferEnded(boolean successfull) {
		transfering=false;
		transfered=0;
		speedMemory = ses.getSpeedInBytesPrSek();
		speedProgress.setString("");
		speedProgress.setValue(0);
				
		if (fileProgress.getValue() == fileProgress.getMaximum()) {
			fileProgress.setForeground(new Color(0,255,0,255));
			fileProgress.setToolTipText(res.getString("The file has been transfered"));
		}else {
			fileProgress.setForeground(new Color(255,0,0,255));
			fileProgress.setToolTipText(res.getString("The filetransfer was aborted"));
		}
	}
	
	public void bytesTransmitted(long[] data) {
		if (transfering==false) {
	  	transfered = (new Long(data[0]).intValue()); //startAt (skipped bytes)
		}
		
		fileProgress.setValue(new Long(data[1]).intValue() + transfered);
		long time2 = new Date().getTime();
		long temp = time2-time;
		if (temp == 0)
			temp++;//to prevent divided by zero
		long speed =((data[1] - speedHelp)/temp)*1000;
		speedHelp=data[1];
		String kbSek = res.getString("Kb/s");
		
		if (transfering) {
			speedProgress.setValue((int)speed);
			speedProgress.setString(new Double(speed/1024) + kbSek);
		}else {
		  speedProgress.setValue(speedSlider.getValue());
			speedProgress.setString(new Double(speedSlider.getValue()/1024) + kbSek);
		}
		
		time = time2;
		transfering = true;
	}
	
	
	private void forceEnd() {
		ended=false;
		if (ses != null)
			setTitle(res.getString("Offline session... username:") + " " + ses.getLogin());
	}
	
	public void userLogedIn(UserSession usersession) {
		ended=false;
		setTitle(res.getString("Online session... username:") + " " + ses.getLogin());
		user.setText(ses.getLogin());
	}
	
	public void userLogedOut(UserSession usersession) {
		ended = true;
		forceEnd();
	}
	
	public void userDisconnected(UserSession userSession, int reasonCode) {
		switch (userSession.getUserState()) {
			case UserSessionObserver.USER_KICKED:
				addText("..........." + res.getString("The user has been kicked") + ".............");
				break;
			case UserSessionObserver.USER_TIMEOUT:
				addText("..........." + res.getString("Timout - To low/no activity") + ".............");
				break;
			case UserSessionObserver.USER_BANNED:
			  addText("..........." + res.getString("The user has been banned and disconnected") + ".............");
				break;
			case UserSessionObserver.USER_AUTO_BANNED:
				addText("..........." + res.getString("Auto Banned due to recognized pattern") + ".............");
				break;
			case UserSessionObserver.USER_KICKED_DUE_TO_SERVER_STOP:
				addText("..........." + res.getString("Kicked due to serverstop") + ".............");
				break;	
			default:
				addText("..........." + res.getString("The user has ended the session") + ".............");
				forceEnd();
		}
	}
	
}