package graphic;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.table.*;
import java.io.*;
import java.util.*;

import graphic.services.*;
import server.*;
import server.services.Crypt;
import setup.*;

public class UserAdmin extends MemoryFrame implements ActionListener{
	
	private JComboBox usersComboBox, groupComboBox;
	private JTextField nameField, usernameField, loginsField, uploadField, downloadField;
	private JPasswordField passField;
	private JCheckBox readBox, listBox, writeBox;
	private ThreeClickCheckBox logBox, bounceBox, adminBox;
	private JLabel nameLabel, usernameLabel, passLabel, logLabel, bounceLabel, loginsLabel, uploadLabel, downloadLabel, readLabel, listLabel, writeLabel, groupLabel, adminLabel;
	private JButton newUserButton, deleteUserButton, logButton, addDirButton, deleteDirButton, correctDirButton, okButton, annullerButton, groupButton;
	private CountField loginCount, uploadCount, downloadCount;
	private JTable dirsTable;
	private DirData model;
	private User[] users;
	private JFileChooser fileChooser = new JFileChooser();
	private GroupAdmin groupAdmin = new GroupAdmin(this);
	private JPanel bib;
	private User current;
		
	public UserAdmin() {
		super("","Users administration");
		setIconImage(ImageHandler.getImage("users.gif"));
		setDefaultCloseOperation(WindowConstants.HIDE_ON_CLOSE);
		fileChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY); 
		GridBagGUI gbg = new GridBagGUI(getContentPane());
		
		gbg.position(0,0);
		gbg.insets(5,2,5,0);
		gbg.add(new JLabel(ImageHandler.getImageIcon("users_big1.gif")));
		
		usersComboBox= new JComboBox();
		usersComboBox.addActionListener(this);
		gbg.position(1,0);
		gbg.size(4,1);
		gbg.anchor("NW");
		gbg.fill('H');
		gbg.weightx(1);
		gbg.add(usersComboBox);
		
		nameLabel = new JLabel();
		gbg.insets(3,2,0,0);
		gbg.position(0,1);
		gbg.size(1,2);
		gbg.fill('N');
		gbg.weightx(0);
		gbg.add(nameLabel);
		
		nameField = new JTextField(10);
		gbg.position(1,1);
		gbg.add(nameField);
		
		usernameLabel = new JLabel();
		gbg.position(0,3);
		gbg.size(1,2);
		gbg.add(usernameLabel);
		
		usernameField = new JTextField(10);
		gbg.position(1,3);
		gbg.add(usernameField);
		
		passLabel = new JLabel();
		gbg.position(0,5);
		gbg.add(passLabel);
		
		passField = new JPasswordField(10);
		gbg.position(1,5);
		gbg.add(passField);

		//GroupCombobox
		groupLabel = new JLabel();
		gbg.position(0,7);
		gbg.add(groupLabel);
		
		groupComboBox = new JComboBox();
		groupComboBox.addActionListener(this);
		groupComboBox.setPreferredSize(new Dimension(110,21));
		gbg.position(1,7);
		gbg.add(groupComboBox);		
		
		//Max Logins
		
		loginsLabel = new JLabel();
		gbg.position(2,1);
		gbg.size(1,2);
		gbg.insets(3,2,0,0);
		gbg.add(loginsLabel);
		
		gbg.position(3,1);
		loginCount = new CountField();
		loginsField = loginCount.field;
		gbg.add(loginCount);
		
		
		//Max upload
		
		uploadLabel = new JLabel();
		gbg.position(2,3);
		gbg.size(1,2);
		gbg.add(uploadLabel);

		uploadCount = new CountField();
		gbg.position(3,3);
		uploadField = uploadCount.field;
		gbg.add(uploadCount);
		
		//Max Download
		
		downloadLabel = new JLabel();
		gbg.position(2,5);
		gbg.size(1,2);
		gbg.insets(3,2,0,0);
		gbg.add(downloadLabel);
		
		downloadCount = new CountField();
		gbg.position(3,5);
		downloadField = downloadCount.field;
		gbg.add(downloadCount);
		
		//log
		logLabel = new JLabel();
		gbg.position(2,7);
		gbg.add(logLabel);
		
		logBox = new ThreeClickCheckBox("",res);
		gbg.size(1,1);
		gbg.position(3,7);
		gbg.add(logBox);
		
		// bounce attack
		bounceLabel = new JLabel();
		gbg.position(2,8);
		gbg.add(bounceLabel);
			
		bounceBox = new ThreeClickCheckBox("",res);
		bounceBox.addActionListener(this);
		gbg.position(3,8);
		gbg.add(bounceBox);
		
		// user is administrator
		adminLabel = new JLabel();
		gbg.position(2,9);
		gbg.add(adminLabel);
			
		adminBox = new ThreeClickCheckBox("",res);
		adminBox.addActionListener(this);
		gbg.position(3,9);
		gbg.add(adminBox);
		
		// ny, slet, log
		JPanel bp = new JPanel();
		GridBagGUI bg = new GridBagGUI(bp);
		gbg.insets(5,2,5,0);
		gbg.position(5,0);
		gbg.size(1,10);
		gbg.add(bp);
		
		newUserButton = new JButton();
		newUserButton.addActionListener(this);
		bg.insets(0,0,5,0);
		bg.fill('H');
		bg.position(0,0);
		bg.add(newUserButton);
		
		deleteUserButton = new JButton();
		deleteUserButton.addActionListener(this);
		bg.position(0,1);
		bg.add(deleteUserButton);
		
		logButton = new JButton();
		logButton.addActionListener(this);
		bg.position(0,2);
		bg.add(logButton);
		
		groupButton = new JButton();
		groupButton.addActionListener(this);
		bg.position(0,3);
		bg.add(groupButton);
		
		okButton = new JButton();
		okButton.addActionListener(this);
		bg.position(0,4);
		bg.add(okButton);
		
		annullerButton = new JButton();
		annullerButton.addActionListener(this);
		bg.position(0,5);
		bg.add(annullerButton);
		
		// Biblioteker
		
		bib = new JPanel();
		GridBagGUI bibg = new GridBagGUI(bib);
		bib.setBorder(new TitledBorder(""));
		
		int[] size1  = {170,90,32};
		
		model = new DirData();
		dirsTable = new JTable();
		dirsTable.setAutoCreateColumnsFromModel(false);
		dirsTable.getTableHeader().setUpdateTableInRealTime(false);
		dirsTable.setModel(model);
		dirsTable.getTableHeader().setResizingAllowed(false);
		dirsTable.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		
    dirsTable.addColumn( new TableColumn(0,model.getColumnWidth(0)) );
    dirsTable.addColumn( new TableColumn(1,model.getColumnWidth(1)) );      
		dirsTable.addColumn( new TableColumn(2,model.getColumnWidth(2), new MyRenderer(), new DefaultCellEditor(new JCheckBox()) ));
		
		dirsTable.getColumn(dirsTable.getColumnName(0)).setCellRenderer(new CellRenderer());

		dirsTable.addMouseListener(new MyMouseListener());
		
		bibg.position(0,0);	
		bibg.anchor("NW");
		bibg.weightx(1);
		bibg.size(1,6);
		bibg.insets(5,15,15,5);
		JScrollPane js = new JScrollPane(dirsTable);
		js.setPreferredSize(new Dimension(295,185));
		js.getViewport().setBackground(new Color(255,255,255));
		bibg.add(js);
		
		readBox = new JCheckBox();
		readBox.addActionListener(this);
		bibg.weightx(0);
		bibg.size(1,1);
		bibg.position(1,0);
		bibg.insets(2,0,0,5);
		bibg.add(readBox);
		
		readLabel = new JLabel();
		bibg.position(2,0);
		bibg.add(readLabel);
		
		listBox = new JCheckBox();
		listBox.addActionListener(this);
		bibg.position(1,1);
		bibg.add(listBox);
		
		listLabel = new JLabel();
		bibg.position(2,1);
		bibg.add(listLabel);
		
		writeBox = new JCheckBox();
		writeBox.addActionListener(this);
		bibg.position(1,2);
		bibg.add(writeBox);
		
		writeLabel = new JLabel();
		bibg.position(2,2);
		bibg.add(writeLabel);		
		
		Dimension size = new Dimension(105,27);//84,27
		addDirButton = new JButton(); //Sets the sizes of this and the next two buttons
		addDirButton.setPreferredSize(size);
		addDirButton.addActionListener(this);
		bibg.position(1,3);
		bibg.size(2,1);
		bibg.add(addDirButton);
		
		deleteDirButton = new JButton();
		deleteDirButton.setPreferredSize(size);
		deleteDirButton.addActionListener(this);
		bibg.position(1,4);
		bibg.add(deleteDirButton);
		
		correctDirButton = new JButton();
		correctDirButton.setPreferredSize(size);
		correctDirButton.addActionListener(this);
		bibg.position(1,5);
		bibg.add(correctDirButton);
		
		gbg.insets(20,20,20,20);
		gbg.size(6,1);
		gbg.position(0,9);
		gbg.fill('B');
		gbg.weightx(1);
		gbg.weighty(1);
		gbg.add(bib);
		
		// Ok... s laver vi lige det sidste!!
		initializeData();
		
		setSize(502,480);
		setResizable(false);
		restore();
	}
	
	public void setText() {
		setTitle(res.getString("Users Administration"));
		
		//.setText(res.getString(""));
		nameLabel.setText(res.getString("Name"));
		usernameLabel.setText(res.getString("Username"));
		passLabel.setText(res.getString("Password"));
		groupLabel.setText(res.getString("Group"));
		loginsLabel.setText(res.getString("Max Logins"));
		loginsLabel.setToolTipText(res.getString("Number of logins of a certain user on one ip adress"));
		uploadLabel.setText(res.getString("Max Upload KB"));
		uploadLabel.setToolTipText(res.getString("The number of KB that the client may send to the server pr. second."));
		downloadLabel.setText(res.getString("Max Download KB"));
		downloadLabel.setToolTipText(res.getString("The number of KB that the client may recive from the server pr. second."));
		logLabel.setText(res.getString("Log"));
		logBox.setName((res.getString("Log")));
		bounceLabel.setText(res.getString("Allow Bounce"));
		bounceBox.setName(res.getString("Allow Bounce Attack"));
		adminLabel.setText(res.getString("Administrator"));
		adminBox.setName(res.getString("The users to access the 'admin' command"));
		newUserButton.setText(res.getString("Add")); 
		deleteUserButton.setText(res.getString("Delete")); 
		logButton.setText(res.getString("Log")); 
		groupButton.setText(res.getString("Groups"));
		okButton.setText(res.getString("OK")); 
		annullerButton.setText(res.getString("Cancel"));
		bib.setBorder(new TitledBorder(res.getString("Directories")));
		dirsTable.getColumnModel().getColumn(0).setHeaderValue(res.getString("Path"));
		dirsTable.getColumnModel().getColumn(1).setHeaderValue(res.getString("Alias"));
		dirsTable.getColumnModel().getColumn(2).setHeaderValue(res.getString("Home"));
		readLabel.setText(res.getString("Read"));
		listLabel.setText(res.getString("List"));
		writeLabel.setText(res.getString("Write"));
		addDirButton.setText(res.getString("Add"));
		deleteDirButton.setText(res.getString("Delete"));
		correctDirButton.setText(res.getString("Edit")); 
		ThreeClickCheckBox.setResourceBundle(res);
	}
		
	protected void initializeData() {
		
		usersComboBox.removeAllItems();
		//Grupper initialiseres.
		initGroups();
		
		//Der fyldes brugere i brugerlisten!
		
		XMLTag[] temp = Conf.getUsers();
		if (temp.length==0)  {
			newUser();
		}else{
			users = new User[temp.length];
			
			for(int i = 0 ; i < users.length; i++) {
				users[i]=new User(temp[i]);
				usersComboBox.addItem(users[i]);
			}
		}
	}
	
	private void initGroups() {
		groupComboBox.removeAllItems();
		
		//Brugergrupper fyldes i listen!	
		XMLTag[] temp = Conf.getGroups();
		//groupComboBox.addItem(new Group(new XMLTag("")));
		try {
			groupComboBox.addItem(new Group(Conf.getRoot().getTagLike("Users")));
		}catch(NoSuchTagException nste) {
			//Intet bruger Tag.
		}
		
		for(int i = 0 ; i < temp.length; i++) {
			groupComboBox.addItem(new Group(temp[i]));		
		}
	}
	
	private User newUser() {
		XMLTag tag = new XMLTag("User");
		current = new User(tag);
		setUser(current);
		return current;
	}
	
	private void setCountText(CountField field, String value, String defaultValue) {
		field.field.setText(value);
		field.setDefaultValue(defaultValue);
	}
	
	private void setUser(User user) {
		nameField.setText(user.getName());
		usernameField.setText(user.getUsername());
		passField.setText(user.getPassword());
		
		setCountText(loginCount,user.getLogins(),user.getDefault("max_logins_per_user"));
		setCountText(uploadCount,user.getUpload(),user.getDefault("max_client_upload"));
		setCountText(downloadCount,user.getDownload(),user.getDefault("max_client_download"));
		
		logBox.setState(user.getLog());
		bounceBox.setState(user.getBounce());
		adminBox.setState(user.getAdmin());
		
		for (int i = 0 ; i < groupComboBox.getItemCount() ; i++ ) {
			if (((Group)groupComboBox.getItemAt(i)).getName().equals(user.getGroupName()))
				groupComboBox.setSelectedIndex(i);
		}	
		
		user.fillDirs();
		
		readBox.setSelected(false);
		listBox.setSelected(false);
		writeBox.setSelected(false);
	}
	
	public void actionPerformed(ActionEvent e) {
		Object source = e.getSource();
		if (source == usersComboBox) {
			if ( current != null && !(current.xml.getParent() == null && nameField.getText().equals("") && usernameField.getText().equals(""))) {
				if (!current.save())
					return; // don't change the user! This one could not be be saved!
			}
						
			User user = (User)usersComboBox.getSelectedItem();
			if (user != null) {
				current = user;
				setUser(user);
			}
		}else if(source == groupComboBox) {
			User user = (User)usersComboBox.getSelectedItem();
			if (user != null) { //instantiering giver event				
				Group g = (Group) groupComboBox.getSelectedItem();
				g.preview();
				
				loginCount.setDefaultValue(user.getDefault("max_logins_per_user"));
				uploadCount.setDefaultValue(user.getDefault("max_client_upload"));
				downloadCount.setDefaultValue(user.getDefault("max_client_download"));
			}
		}else if (source == deleteDirButton){
			int i = dirsTable.getSelectedRow();
			if (i >=0 ) 
				model.removeRow(i);
			readBox.setSelected(false);
			listBox.setSelected(false);
			writeBox.setSelected(false);			
		}else if(source == correctDirButton) {
			 int row = dirsTable.getSelectedRow();
			 if (row>=0) {
 			 	 Object o = dirsTable.getValueAt(row,0);
				 String path = o.toString();
				 fileChooser.setSelectedFile(new File(path));
				 int returnVal = fileChooser.showDialog(this,res.getString("OK"));
				 if (returnVal == JFileChooser.APPROVE_OPTION) {
				 	Dir d = (Dir)o;
					d.setDir(fileChooser.getSelectedFile().getAbsolutePath());
					model.fireTableDataChanged();
				 }
			 }
		}else if(source == listBox || source == readBox || source == writeBox){
			int row = dirsTable.getSelectedRow();
			if (row >= 0 ) {
				Dir dir = (Dir) dirsTable.getValueAt(row,0);
				dir.setList(listBox.isSelected());
				dir.setRead(readBox.isSelected());
				dir.setWrite(writeBox.isSelected());
			}
		}else if(source == logButton) {
			User user = (User) usersComboBox.getSelectedItem();	
			new UserList(user.getUsername(),false);
		}else if(source == groupButton) {
			groupAdmin.setGroup(((Group)groupComboBox.getSelectedItem()).xml);		
			groupAdmin.setVisible(true);
		}else if(source == okButton) {
			if ( usersComboBox.getItemCount() == 0 && current.xml.getParent() == null && nameField.getText().equals("") && usernameField.getText().equals(""))
				setVisible(false);
			else {
				if(current.save())
					setVisible(false);
			}
		}else if(source == annullerButton) {
			newUser();
			setVisible(false);
		}else if(source == newUserButton) {
			if (current!=null)
				current.save();
			newUser();
		}else if(source == deleteUserButton) {
			User user = (User) usersComboBox.getSelectedItem();
			if (user != null) {
				int i = JOptionPane.showConfirmDialog(null, res.getString("Are you shure you wish to delete this user?"), res.getString("Shure?"), JOptionPane.YES_NO_OPTION);
				if (i == 0)  {
					newUser();	
					user.getTag().getParent().removeTag(user.getTag());
					usersComboBox.removeItem(user);
				}
			}else
				newUser();
		}else if(source == addDirButton) {
			int returnVal = fileChooser.showDialog(this,res.getString("OK"));
    	if(returnVal == JFileChooser.APPROVE_OPTION) {
				boolean found = false;
				Dir d;
				for( int i = 0 ; i < dirsTable.getRowCount() ; i++) {
					d = model.getRow(i);
					if (d.getName().toLowerCase().equals(fileChooser.getSelectedFile().getAbsolutePath().toLowerCase()))
						found=true;	
				}
				if (!found) {
					Dir dir = new Dir(getNewDir(fileChooser.getSelectedFile().getAbsolutePath()),true,"User");
					model.add(dir);
					dirsTable.setRowSelectionInterval(dirsTable.getRowCount()-1,dirsTable.getRowCount()-1);
					readBox.setEnabled(true);
					listBox.setEnabled(true);
					writeBox.setEnabled(true);
					deleteDirButton.setEnabled(true);
					correctDirButton.setEnabled(true);
					readBox.setSelected(false);
					listBox.setSelected(false);
					writeBox.setSelected(true);
					readBox.doClick();
					listBox.doClick();
					writeBox.doClick();
				}else
		    	JOptionPane.showMessageDialog(null, res.getString("The Directory already exists. No action was taken."), res.getString("Notice") ,JOptionPane.INFORMATION_MESSAGE); 
    	}
		}
	}
	
	public void setGroup(XMLTag xml) {
		Group tmp = (Group) groupComboBox.getSelectedItem();
		
		initGroups();//Opdaterer listen med nye/slettede
		
		Group g;
		for (int i = groupComboBox.getItemCount()-1; i >= 0 ; i--) {
			g = (Group) groupComboBox.getItemAt(i);
			if (tmp.xml == g.xml) {
				groupComboBox.setSelectedIndex(i);
				groupComboBox.updateUI();
				break;
			}
		}		
	}
	
	public XMLTag getNewDir(String navn) {
		XMLTag tag = new XMLTag("Directory");
		tag.addOption("name",navn);
		tag.addOption("list","no");
		tag.addOption("read","no");
		tag.addOption("write","no");
		return tag;
	}
	
	private class CellRenderer extends DefaultTableCellRenderer {
		public void setValue(Object obj) {
			if(( (Dir) obj).getParent().equals("Group"))
				setForeground( Color.red );
			else
				setForeground( Color.black );
			setText(obj.toString());
		}
	}
	
	private class User {
	
		public XMLTag xml;
	
		public User(XMLTag xml) {
			this.xml = xml;
		}
		
		public XMLTag getTag() {
			return xml;
		}

		private String get(String name) {
			return Conf.getUserOption(xml,name);
		}
		
		private void set(String option, String value) {
			try {
				if (value == null) {
					xml.removeOption(option);
				}else {
					try {
						xml.setOptionValue(option, value);
					}catch(NoSuchOptionException nse) {
						xml.addOption(option, value);
					}
				}
			}catch(NoSuchOptionException nse) {
				//Option eksisterer ikke / er allerede slettet.
			}		
		}
		
		public String getName() {
			return get("name");
		}

		public String getUsername() {
			return get("username");
		}
		
		public String getPassword() {
			return new Crypt(getUsername()).decrypt(get("password"));
//			return get("password");
		}

		public int getLog() {
			return getBooleanFromUser("log");
		}
		
		public int getBounce() {
			return getBooleanFromUser("allow_bounce_attack");
		}
		
		public int getAdmin() {
			return getBooleanFromUser("admin");
		}
				
		private int getBooleanFromUser(String option) {
			int state = ThreeClickCheckBox.DISABLED;
			try {
				String str = xml.getOptionValue(option);
				if (str.equals("yes"))
					state = ThreeClickCheckBox.SELECTED;
				else if (str.equals("no"))
					state = ThreeClickCheckBox.DESELECTED;
			}catch(NoSuchOptionException nse) {
			}
			return state;		
		}
		
		private void setBool(String option, int state) {
			String ok=null;
			switch (state) {
				case ThreeClickCheckBox.SELECTED:
					ok="yes";
					break;
				case ThreeClickCheckBox.DISABLED:
					ok=null;
					break;
				case ThreeClickCheckBox.DESELECTED:
					ok="no";
					break;
			}	
			set(option,ok);
		}
		
		public String getUpload() {
			return get("max_client_upload");
		}
		
		public String getDownload() {
			return get("max_client_download");
		}
		
		public String getLogins() {
			return get("max_logins_per_user");
		}
		
		public String getDefault(String value) {
			String val = null;
			Group g = (Group) groupComboBox.getSelectedItem();
			if (g != null)
				val = g.get(value);
			if (val == null || val.equals("")) {
				try{
					val = Conf.getRoot().getQuickOptionValue("Server."+value);
				}catch(NoSuchTagException nsoe) {
				}
			}
			return val;
		}
		
		public Group getGroup() {
			Group g;
			for(int i = groupComboBox.getItemCount()-1 ; i >= 0 ; i--) {
				g = (Group) groupComboBox.getItemAt(i);
				if (g.xml == xml.getParent())
					return g;
			}
			return null;	
		}
		
		public void fillDirs() {
			model.reset();
			
			//Brugergruppens biblioteker
			Group g = getGroup();
			if (g != null)
				g.preview();
			
			//Brugerens egne biblioteker
			XMLTag[] arr = getDirs();
			Dir d;
			for(int i = 0 ; i < arr.length ; i++) {
				d = new Dir(arr[i],false, "User");
				model.add( d );
			}
		}
		
		public XMLTag[] getDirs() {
			try {
				return xml.getTagsLike("Directory");
			}catch(NoSuchTagException nst) {
				return new XMLTag[] {};
			}
		}			
				
		public String getGroupName() {
			XMLTag parent = xml.getParent();
			
			if (parent != null && parent.tagName.equals("Usergroup")) {
				try{
					return parent.getOptionValue("name");
				}catch(NoSuchOptionException nsoe) {
					return "";
				}
			}else
				return "";
		}
		
		public boolean save() {
						
			if (nameField.getText().equals("")) {
				JOptionPane.showMessageDialog(null, res.getString("A name MUST be deffined."), res.getString("Notice") ,JOptionPane.WARNING_MESSAGE); 
				nameField.requestFocus();
				return false;
			}
			if (usernameField.getText().equals("")) {
				JOptionPane.showMessageDialog(null, res.getString("An username MUST be deffined."), res.getString("Notice") ,JOptionPane.WARNING_MESSAGE); 
				usernameField.requestFocus();
				return false;
			}
			
			set("name", nameField.getText());
			set("username", usernameField.getText());
			set("password", new Crypt(usernameField.getText()).encrypt(passField.getPassword()));
			set("max_client_upload", uploadCount.getValue());
			set("max_client_download", downloadCount.getValue());
			set("max_logins_per_user", loginCount.getValue());
			setBool("log", logBox.getState());
			setBool("allow_bounce_attack", bounceBox.getState());
			setBool("admin", adminBox.getState());
			
			int size = dirsTable.getRowCount();
			Dir dir;

			//Tilfj nye tags, og saver alle
			for(int i = 0 ; i < size ; i++) {
				dir = model.getRow(i);
				if (dir.isNew())
					xml.addTag(dir.getTag());
				dir.save();	
			}
			//Fjern slettede tags
			XMLTag[] dirs = getDirs(); 
			boolean found;
			for (int i = 0 ; i < dirs.length; i++) {
				found = false;
				for (int j = 0 ; j < size; j++) {
					dir = model.getRow(j);
					if (dir.equals(dirs[i])) {
						found = true;
						break;
					}
				}
				if (!found)
					xml.removeTag(dirs[i]);
			}
		
			//Checker om brugeren er nyoprettet
			if (current.xml.getParent() == null) {
				try {
					Conf.getRoot().getTagLike("Users").addTag(current.xml);
					usersComboBox.addItem(current);
					usersComboBox.setSelectedItem(current);
				}catch(NoSuchTagException nse) {
				}
			}
			//Sets group. Must come after the check above.
			Group g = (Group) groupComboBox.getSelectedItem();
			if (g != null)
				g.addUser(this);
			else
				System.out.println("The user was not in any group!");	
			
			return true;
		}
		
  	public String toString() {
			if (getName().equals(""))
				return getUsername();
			else	
				return getUsername() + " (" + getName() + ")";
		}
	}
	
	private class MyRenderer extends JCheckBox implements TableCellRenderer{

		public MyRenderer() {
			setOpaque(true);
		}						
		
		public Component getTableCellRendererComponent(JTable table ,Object value, boolean isSelected, boolean hasFocus, int row, int column) {
			if (value instanceof Boolean) {
				Boolean b = (Boolean) value;
				setSelected(b.booleanValue());
			}
			setBackground(isSelected && !hasFocus ? table.getSelectionBackground() : table.getBackground());
			setForeground(isSelected && !hasFocus ? table.getSelectionForeground() : table.getForeground());
			return this;
		}
	}
	
	private class Group {
		public XMLTag xml;
		
		public Group(XMLTag xml) {
			this.xml=xml;
		}
		
		public String get(String option) {
			try {
				return xml.getOptionValue(option);
			}catch(NoSuchOptionException nse) {
				return "";
			}
		}
		
		public XMLTag[] getDirs() {
			try {
				return xml.getTagsLike("Directory");	
			}catch(NoSuchTagException nst) {
				return new XMLTag[] {};
			}	
		}
		
		public String getName() {
			return get("name");
		}
		
		public String toString() {
			return getName();
		}
		
		//skriver directories i dirstable.
		public void preview() {
			Dir d;
			for(int i = dirsTable.getRowCount()-1 ; i >= 0 ;i--) {
				d = model.getRow(i);
				if (d.getParent().equals("Group"))
					model.removeRow(i);
			}
			//Brugergruppens biblioteker
			XMLTag[] arr = getDirs();
			for(int i = 0 ; i < arr.length ; i++) {
				model.add( new Dir(arr[i],false, "Group"),0 );
			}
		}
		
		public void addUser(User user) {
			XMLTag parent = user.xml.getParent();
			if (parent!=null)
				parent.removeTag(user.xml);
			xml.addTag(user.xml);
		}
	}
	
	private class Dir {
		
		private XMLTag xml;
		private boolean read,list,write,newOne;
		private Boolean home;
		private String parent,alias;
		
		public Dir(XMLTag xml, boolean newOne, String parent) {
			this.xml = xml;
			this.newOne = newOne;
			this.parent = parent;
			read  = get("read").equals("yes");
			list  = get("list").equals("yes");
			write = get("write").equals("yes");
			alias = get("alias");
			home  = new Boolean(get("home").equals("yes"));
		}
		
		public void setDir(String path) {
			try {
				xml.setOptionValue("name",path);
			}catch(NoSuchOptionException nse) {
			}
		}
		
		public String getParent() {
			return parent;
		}
		
		public boolean equals(XMLTag xml) {
			return this.xml == xml;
		}
		
		public boolean isNew() {
			return newOne;
		}
		
		public Boolean isHome() {
			return home;
		}
		
		public String toString() {
			return get("name");
		}
		
		public String getName() {
			return get("name");
		}
		
		public String getAlias() {
			return alias;
		}
		
		public void setAlias(String alias) {
			this.alias = alias;
		}
		
		public void setHome(Boolean home) {
			this.home = home;
		}
		
		public void setRead(boolean on) {
			read = on;
		}
		
		public void setList(boolean on) {
			list = on;
		}
		
		public void setWrite(boolean on) {
			write = on;
		}
		
		public void save() {
			set("list", list);
			set("read", read);
			set("write", write);
			
			if (home.booleanValue()) {
				try {
					xml.setOptionValue("home", "");
				}catch(NoSuchOptionException nse) {
					xml.addOption("home","");
				}
				set("home",home.booleanValue());
			}else {
				try {
					xml.removeOption("home");
				}catch(NoSuchOptionException nse) {
				}
			}
			
			try {
				xml.setOptionValue("alias",alias);
			}catch(NoSuchOptionException nse) {
				xml.addOption("alias",alias);
			}
		}
		
		private void set(String option, boolean on) {
			String value;
			if (on)
				value="yes";
			else
				value="no";	
			
			try {
				xml.setOptionValue(option,value);
			}catch(NoSuchOptionException nse) {
			}
		}
		
		private String get(String option) {
			try {
				return xml.getOptionValue(option).trim();
			}catch(NoSuchOptionException nse) {
				return "";
			}
		}
		
		public boolean getList() {
			return list;
		}
		
		public boolean getRead() {
			return read;
		}
		
		public boolean getWrite() {
			return write;
		}
		
		public XMLTag getTag() {
			return xml;
		}
	}
	
	public class MyMouseListener extends MouseAdapter {
		public void mouseReleased(MouseEvent e) {
			Dir dir = model.getRow(dirsTable.getSelectedRow());
			
			readBox.setSelected(dir.getRead());
			listBox.setSelected(dir.getList());
			writeBox.setSelected(dir.getWrite());
			
			if (dir.getParent().equals("Group")) {
				readBox.setEnabled(false);
				listBox.setEnabled(false);
				writeBox.setEnabled(false);
				deleteDirButton.setEnabled(false);
				correctDirButton.setEnabled(false);
			}else {
				readBox.setEnabled(true);
				listBox.setEnabled(true);
				writeBox.setEnabled(true);	
				deleteDirButton.setEnabled(true);
				correctDirButton.setEnabled(true);
			}
		}
	}
	
	public class DirData extends AbstractTableModel {
  
		private Vector v = new Vector(10);

		//int[] size = {170,90,32};
		int[] size = {170,86,36};
		
		public int getColumnWidth(int i) {
			return size[i];
		}
		
		public int getRowCount() {
			return v.size();
	  }
	  
		public int getColumnCount() {
			return size.length;
	  }
	  
		public Object getValueAt(int row, int column) {
			Dir d = (Dir) v.get(row);
			switch (column){
			
				case 0:
					return d;
				case 1:
					return d.getAlias();
				case 2:
					return d.isHome();
			}
			return "Table column not deffined!";
	  }
		
		public void setValueAt(Object aValue, int rowIndex, int columnIndex)  {
			Dir d = (Dir)v.get(rowIndex);
			
			switch(columnIndex){
				case(1):
					String name=aValue.toString();
					if (System.getProperty("os.name").toLowerCase().startsWith("windows")) {
						if(name.length() > 2 && name.charAt(1) == ':' && name.indexOf('*')==-1 && name.indexOf('?')==-1 && name.indexOf('"')==-1 && name.indexOf('<')==-1 && name.indexOf('>')==-1 && name.indexOf('|')==-1 && name.indexOf(':',2)==-1)
							d.setAlias(new File(aValue.toString()).getAbsolutePath().trim());
						else if (name.equals(""))	
							d.setAlias("");
						else
							JOptionPane.showMessageDialog(null, res.getString("The Filename is not valid!"), res.getString("Notice") ,JOptionPane.WARNING_MESSAGE);							
					}					
					break;
				case(2):
					for (int i = getRowCount()-1 ; i >= 0 ; i--) {
						getRow(i).setHome(new Boolean(false));
						fireTableCellUpdated(i,columnIndex);
					}
					d.setHome((Boolean) aValue);
					fireTableCellUpdated(rowIndex,columnIndex);
					break;
			}
		}
		
		public boolean isCellEditable(int rowIndex, int columnIndex) {
			if ((columnIndex == 2 || columnIndex == 1) && !getRow(rowIndex).getParent().equals("Group"))
				return true;
			return false;	
		}
		
		public void add(Dir d) {
			v.add(d);
			fireTableDataChanged();
		}
		
		public void add(Dir d, int place) {
			v.add(place, d);
			fireTableDataChanged();
		}
		
		public Dir removeRow(int i) {
			Dir d = (Dir)v.remove(i);
			fireTableDataChanged();
			return d;
		}
		
		public void reset() {
			v = new Vector(10);
			fireTableDataChanged();
		}

		public Dir getRow(int i) {
			return (Dir)v.get(i);
		}		
	}
}