package graphic.services;

import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;

public class CountField extends JPanel implements ActionListener, KeyListener, FocusListener{
	
	public JTextField field;
	private JButton up,down;
	private String val="";
	
	public CountField() {
		GridBagGUI gbg = new GridBagGUI(this);
		
		field = new JTextField(5);
		field.addKeyListener(this);
		field.addFocusListener(this);
		gbg.insets(0,0,0,2);
		gbg.size(1,2);
		gbg.position(3,5);
		gbg.add(field);
		
		up = getButton("up","+1");
		gbg.anchor("SW");
		gbg.size(1,1);
		gbg.position(4,5);
		gbg.insets(0,0,1,0);
		gbg.add(up);
		
		down = getButton("down","-1");
		gbg.insets(1,0,0,0);
		gbg.anchor("NW");
		gbg.position(4,6);
		gbg.add(down);

	}
	
	//retunerer vrdien, eller null hvis den er lig defaultValue
	public String getValue() {
		String text = field.getText();
		if (text.equals(val))
			return null;
		else
			return text;	
	}
	
	public void setDefaultValue(String val) {
		field.setToolTipText("Standard er ["+val+"]");
		if (this.val.equals(field.getText()))//flg standarden igen
			field.setText(val);
		
		this.val = val;
		test();
	}
	
	public JButton getButton(String name, String toolTipTekst) {
		JButton j = new JButton();		
		ImageIcon im = new ImageIcon("image/" + name + ".gif");
		j.setToolTipText(toolTipTekst);
		j.setIcon(im);
		j.setPreferredSize(new Dimension(im.getIconWidth(), im.getIconHeight()));
		j.setBorder(new EmptyBorder(0,0,0,0));
		j.addActionListener(this);
		return j;
	}
	
	public void actionPerformed(ActionEvent e) {
		Object source = e.getSource();
		
		if (source == up) {
			count(1);
		}else if (source == down) {
			count(-1);
		}
	}
	
	public void count(int i) {
		if (!isNum())
			field.setText("0");
		field.setText(""+(Integer.parseInt(field.getText())+i));
		test();
	}
	
	public void focusGained(FocusEvent e) {
		field.setForeground(Color.black);
	}
	
	public void focusLost(FocusEvent e) {
		test();
	}

	public void keyReleased(KeyEvent e) {
		if(e.getKeyCode() == KeyEvent.VK_ENTER)
			test();
	}
	
	public void keyPressed(KeyEvent e) {
	}
	
	public void keyTyped(KeyEvent e) {
	}	
	
	private void test() {
		String text = field.getText();
		if (text.equals("") || text.equals(val)) {
			field.setText(val);
			field.setForeground(Color.red);
		}else {
			if (isNum())
				field.setForeground(Color.black);
			else {
				JOptionPane.showMessageDialog(field, "Feltet tager kun tal!"); 	
				field.requestFocus();
			}
		}
	}
	
	private boolean isNum() {
		try {
			Integer.parseInt(field.getText());
			return true;
		}catch(NumberFormatException nfe) {
			return false;
		}
	}
}