package graphic.services;

import java.io.*;
import java.util.*;
import java.net.*;
import javax.swing.*;
import java.awt.*;

public class ImageHandler {

  // Revised BCR using java's resource mechanism
	public static ImageIcon getImageIcon(String name) {
    return getImageIcon(ImageHandler.class, name);
  }

  public static ImageIcon getImageIcon(Class owningResource, String fileName) {
    URL url = convertWhiteSpace(owningResource.getResource("/image/" + fileName));
    if (url == null)
      return null;
    return new ImageIcon(Toolkit.getDefaultToolkit().createImage(url));
  }
	
	public static Image getImage(String name) {
    ImageIcon icon = getImageIcon(name);
		return (icon != null ? icon.getImage() : null);
	}
	
	public static String convertWhiteSpace(String path) {
		StringTokenizer s = new StringTokenizer(path,"%20");
		String tmp="";
		if (s.hasMoreTokens())
			tmp = s.nextToken();
		
		while(s.hasMoreTokens())
			tmp+=" " + s.nextToken();

		return tmp;
	}
	
	public static URL convertWhiteSpace(URL url) {
		try {
			return new URL(convertWhiteSpace(url.toString()));
		}catch(MalformedURLException e) {
			return null;
		}
		//return tmp.substring(tmp.indexOf('/')+1);
			
	}
}
