package graphic.services;

/**
 * This interface is to be implemented by the one who wants to make a sorting criteria for a JQTable.
 * The classes one method is called every time two celles is compared to each other. If a comparisment is not possible,
 * -2 should be returned, and comparisment will continue as normal.
 */
public interface JQTableSortMethod{
  /**
   * Compares the object itself(me) with another object(other). <br>
   * If the object that is compared with is larger than the object itself -1 should be returned.
	 * If they are equal, 0 should be returned, and if the compared object is less than the object itself,
	 * 1 should be returned.
   * If the objects cannot be compared, -2 should be returned. After this, the object wil be compared after standard
	 * sorting methods (String and int) <br><br>
	 * <b>a method to comparisment of numbers would look like this:</b><br><br>
   *
   *public int compareTo(Object me, Object other){<br>
   *&nbsptry{<br>
   *&nbsp&nbsp&nbspint num1 = Integer.parseInt(me.toString());<br>
   *&nbsp&nbsp&nbspint num2 = Integer.parseInt(other.toString());<br>
   *   <br>
   *&nbsp&nbsp&nbspif (num1 == num2)<br>
   *&nbsp&nbsp&nbsp&nbsp&nbspreturn 0;<br>
   *&nbsp&nbsp&nbspif (num1 < num2)<br>
   *&nbsp&nbsp&nbsp&nbsp&nbspreturn -1;<br>
   *&nbsp&nbsp&nbspelse<br>
   *&nbsp&nbsp&nbsp&nbsp&nbspreturn 1;<br>
   *   <br>
   *&nbsp}catch(NumberFormatException nfe){<br>
   *&nbsp&nbsp&nbspreturn -2;<br>
   *&nbsp}<br>
   *}<br>
   *
   *
   * @param   me  The object it selv.
   * @param   other  The object to compare with
   * @return     -2, -1, 0, 1
   */
  public int compareTo(Object me, Object other);
}