package graphic.services;

import java.io.*;
import java.awt.*;
import java.util.*;
import java.util.jar.*;
import java.util.zip.*;
import javax.swing.*;

public class LocaleBox extends JComboBox {
	public LocaleBox() {
		super();
		
		setPreferredSize(new Dimension(50,22));
		setFont(new Font("Courier New",Font.PLAIN,11));
		
		try {
			JarFile f = new JarFile("JQData-FTP.jar");
			
			Enumeration enu = f.entries();
			String name;
			while (enu.hasMoreElements()) {
				ZipEntry e = (ZipEntry) enu.nextElement();
				name = e.getName();
				if (name.startsWith("graphic/resources/FTPResources"))
					add(name.substring(name.lastIndexOf('/')+1, name.length()));
			}
		}catch(IOException ioe) {
		}
		File f = new File("./graphic/resources");
		String[] arr = f.list();
		if (arr != null) {
			File file;
			for (int i = 0 ; i < arr.length; i++) {
				file = new File(arr[i]);
				add(file.getName());
			}
		}
		
		ResourceBundle res = ResourceBundle.getBundle("graphic.resources.FTPResources");
		if (contains(res.getLocale()))
			setSelectedItem(res.getLocale().getCountry());
		else
			setSelectedItem(new Locale("UK"));	
	}
	
	public boolean contains(Locale locale) {
		int items = getItemCount();
		
		for (int i = 0 ; i < items ; i++)
			if (getItemAt(i).equals(locale.getCountry()))
				return true;
		return false;
	}
	
	public Locale getSelectedLocale() {
		Item i = (Item) getSelectedItem();
		return i.locale;
	}
	
	public boolean setSelectedLocale(Locale locale) {
		int items = getItemCount();
		Item item;
		for (int i = 0 ; i < items ; i++) {
			item = (Item)getItemAt(i);
			if (item.locale.toString().equals(locale.toString())) {
				setSelectedItem(item);
				return true;
			}
		}
		return false;			
	}
	
	private void add(String name) {
		try {
			if (name.endsWith(".class") && Class.forName("graphic.resources."+name.substring(0,name.length()-6)).newInstance() instanceof ListResourceBundle) {
				int i = name.length();
				if (name.charAt(i-9) == '_') {
					addItem(new Item(name));
				}
			}
		}catch(Exception e) {
			System.out.println(e);
		}
	}
	
	public class Item extends Object{
		
		public Locale locale;
		
		public Item( String filename ) {
			int i = filename.length();
			String country = filename.substring(i-8,i-6).toUpperCase();
			String language = filename.substring(i-11,i-9).toLowerCase();
			locale = new Locale (language,country);
		}
		
		public String toString() {
			return locale.getCountry();
		}
	}
}