package graphic.services;

import javax.swing.border.*;
import javax.swing.*;
import java.awt.event.*;
import java.awt.*;

public class SmartButton extends JButton {
	
	private Border out = new EmptyBorder(1,1,1,1);
	private Border in = new LineBorder(Color.gray);
	
	public SmartButton(String name, String toolTipTekst) {
		setToolTipText(toolTipTekst);
		
		ImageIcon im = ImageHandler.getImageIcon(name + ".gif");
		setIcon(im);
		setPreferredSize(new Dimension(im.getIconWidth()+4, im.getIconHeight()+4));
		setBorder(out);
		addMouseListener(new Mylistener());
	}
	
	class Mylistener extends MouseAdapter {
	
		public void mouseEntered(MouseEvent e) {
			setBorder(in);
		}
		
    public void mouseExited(MouseEvent e) {
			setBorder(out);
    }

	}
}