package graphic.services;

import javax.swing.*;
import javax.swing.border.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;

public class ThreeClickCheckBox extends JCheckBox implements MouseListener{
	
	private String name="";
	public final static int DISABLED = 0;
	public final static int DESELECTED  = 1;
	public final static int SELECTED    = 2;
	private int state = 1;
	private static ResourceBundle res;
	private static Vector v;
	
	public ThreeClickCheckBox(String name, ResourceBundle resource) {
		res = resource;
		if (v == null)
			v = new Vector();
		
		v.add(this);	
		
		this.name = name;
		addMouseListener(this);
		MouseListener[] arr = getMouseListeners();
		removeMouseListener(arr[0]);
	}
	
	public void mouseClicked(MouseEvent e) {
	}        
  public void mouseEntered(MouseEvent e) {
  }
	public void mouseExited(MouseEvent e) {
	}
	public void mousePressed(MouseEvent e) {
	}
	public void mouseReleased(MouseEvent e) {
		setState(newState());
	}
	
	public void setState(int state) {
		this.state=state;
		switch (state) {
			case SELECTED:
				setSelected(true);
				setEnabled(true);
				setToolTipText(name + " " + res.getString("is enabled"));
				break;
			case DISABLED:
				setEnabled(false);
				setSelected(true);
				setToolTipText(name + " " + res.getString("is using the same standards as the group/server"));
				break;
			case DESELECTED:
				setEnabled(true);
				setSelected(false);
				setToolTipText(name + " " + res.getString("is disabled"));
				break;
		}	
	}
	
	private int newState() {
		if (!isSelected())
			state = SELECTED;
		else if (isSelected() && isEnabled())
			state = DISABLED;
		else if (isSelected() && !isEnabled()) {
			state = DESELECTED;
		}
		return state;
	}
	
	public int getState() {
		return state;
	}
	
	private void setResourceBundle() {
		setState(state);
	}
	
	public static void setResourceBundle(ResourceBundle bundle) {
		res = bundle;
		
		for (int i = v.size()-1; i >= 0 ; i--)
			((ThreeClickCheckBox)v.get(i)).setResourceBundle(); 
	}
	
	public void setName(String name) {
		this.name = name;
		setState(state);
	}

}