package graphic.services.tree;

import java.io.*;
import java.util.*;

/**
 * The class is a binary tree, that can sort objects after the toString() method,
 * or by the TreeNodes method (after its getSortingQualifier()). 
 */
public class BinTree{
  
  protected TreeNode Root;
  
  private LinkedList list = new LinkedList();

  private TreeNode insert(TreeNode tree, TreeNode newElement){
    if (tree==null){
//      System.out.println("plads fundet til: " + newElement.getSortingQualifier());
      return newElement;
    }else if (newElement.compareTo(tree) < 0 ){
//      System.out.println("Element til ventre: " + newElement.getSortingQualifier());
      tree.setLeftNode(insert(tree.getLeftNode(), newElement));
    }else{
//      System.out.println("Element til hjre: " + newElement.getSortingQualifier());
      tree.setRightNode(insert(tree.getRightNode(), newElement));
    }
    return tree;
  }
  

  /**
   * Inserts the new TreeNode element into the tree
   *
   * @param   newElement  The new TreeNode
   */
  public void insert(TreeNode newElement){
//    System.out.println("NYT ELEMENT: " + newElement.getSortingQualifier());
    Root = insert(Root, newElement);
//    System.out.println("ELEMENT PLACERET: " + newElement.getSortingQualifier());
//    System.out.println("");

  }
  

  /**
   * Inserts a new Object in the tree
   *
   * @param   newElement  The new Element
   */
  public void insert(Object newElement){
    Root = insert(Root, new DefaultTreeNode(newElement));
  }

  private LinkedList udskriv(TreeNode tree){
    if (tree!=null){
      udskriv(tree.getLeftNode());
      list.add(tree.getElement());
      udskriv(tree.getRightNode());
    }
    return list;
  }
  

  /**
   *  Returns a sorted tree in ascending order.
   *
   * @return     tr.
   */
  public LinkedList udskriv(){
    return udskriv(Root);
  }
  

  /**
   * Seeks for a String in the Tree, and returns true if found
   *
   * @param   target  element to find.
   * @return     true = found, false = not found.
   */
  public boolean soeg(String target) {
    return soeg(target,Root);
  }
  

  /**
   * Seeks for a String in the Tree, and returns true if found
   *
   * @param   target  element to find
   * @param   tree  element to start at.
   * @return     true = found, false = missing.
   */
  public boolean soeg(String target,TreeNode tree) {
    if (tree!=null) {
      if (tree.getSortingQualifier().intern()==target)
        return true;
      if (target.compareTo(tree.getSortingQualifier()) < 0 )
        // target skal findes i venstre undertr
        return soeg(target,tree.getLeftNode());
      else
        // target skal findes i hjre undertr
        return soeg(target,tree.getRightNode());
    }
    else
      return false;
  }
}