package graphic.services.tree;
/**
 * This class is a default implementation of a TreeNode. It is sorted after the toString() method.
 */
public class DefaultTreeNode implements TreeNode{
  
  private Object element;
  private TreeNode left;
  private TreeNode right;

  /**
   * Set-Constructor.
   *
   * @param   element
   */
  public DefaultTreeNode(Object element){
   this.element=element;
  }
  
  public String getSortingQualifier(){
    return element.toString();
  }
  
  public void setLeftNode(TreeNode left){
    this.left = left;
  }

  public void setRightNode(TreeNode right){
    this.right = right;
  }

  public TreeNode getLeftNode(){
    return left;
  }

  public TreeNode getRightNode(){
    return right;
  }
  
  public Object getElement(){
    return element;
  }
  
  public int compareTo(TreeNode treeNode){
    return this.getSortingQualifier().toLowerCase().compareTo(treeNode.getSortingQualifier().toLowerCase());
  }

}