package graphic.services.tree;
/**
 * This interface is used as a node in a Binary Tree.
 *
 */
public interface TreeNode{


  /**
   * Returns what should be sorted by.
   *
   * @return     by Object fx.( object.toString() )
   */
  public String getSortingQualifier();


  /**
   * Saves 'LeftNode' in the data core.
   *
   * @param   left  
   */
  public void setLeftNode(TreeNode left);


  /**
   * Saves 'RightNode' in the data core.
   *
   * @param   left  
   */
  public void setRightNode(TreeNode left);


  /**
   * Returns LeftNode
   *
   * @return     .
   */
  public TreeNode getLeftNode();


  /**
   * Returns RightNode
   *
   * @return     .
   */
  public TreeNode getRightNode();
  

  /**
   * Returns the elementet - Not 'this', but the object, that tis node is holding.
   *
   * @return     elementet.
   */
  public Object getElement();


  /**
	 * Compares the node with another node <br>
   * If the node that is beeing compared with is larger than the node itself, -1 is returned. If they are alike,
	 * 0 is returned, and if the passed node is less than itself, 1 is returned..
   *
   * @param   treeNode  The node that is compared with
   * @return     -1 ,0,1
   */
  public int compareTo(TreeNode treeNode);
  
}