package server;

import java.util.*;

/**
 * The class represents a single session fetched from a logfile. It should be obtained though LogFileReader.
 */

public class LogFileSession implements Session{

	private Vector conversation;
	private int sessionNr;
	private String ip,time,login;	


	/**
	 * Makes a new LogFileSession
	 *
	 * @param   login  loginname
	 * @param   sessionNr  autogenerated number
	 * @param   ip  ip-address
	 * @param   time  	of login
	 * @param   conversation  the clients conversation with the server
	 */
	protected LogFileSession(String login, int sessionNr, String ip, String time, Vector conversation) {
		this.login = login;
		this.conversation = conversation;
		this.ip = ip;
		this.time = time;
		this.sessionNr = sessionNr;
	}
	

	/**
	 * Compares this object to another. The criterias is that login, sessionNr,
	 * ip, and time is alike int the two objects.
	 * The conversations between the two objects are NOT compared of performance considerations.
	 *
	 * @param   logFileSession  tje object that should be compared whith, 
	 * @return     true if the two are alike
	 */
	public boolean equals(LogFileSession logFileSession) {
		if(!ip.equals(logFileSession.ip))
			return false;
		if(!time.equals(logFileSession.time))
			return false;
		if(!login.equals(logFileSession.login))
			return false;
		if(!(sessionNr == logFileSession.sessionNr))
			return false;
		return true;
	}	

	public String getLogin() {
		return login;
	}

	public String getClientIP() {
		return ip;
	}

	public String getLogonTime() {
		return time;
	}
	
	public int getSessionNr() {
		return sessionNr;
	}
	
	public Vector getConversation() {
		return conversation;
	}

}