package server;

import java.util.*;


/**
 * Represents a Session from a client.
 */
public interface Session {

	/**
	 * The clients ip.
	 *
	 * @return     ip
	 */
	public String getClientIP();
	
	
	/**
	 * The clients loginname.
	 *
	 * @return     loginname
	 */
	public String getLogin();
	
	
	/**
	 * The time the client logged onto the server. The format is: D. 23.05.2002  kl. 18:00:27
	 *
	 * @return     date+time
	 */
	public String getLogonTime();
	
	
	/**
	 * The sessionnumber, that this sessionnumber has.
	 *
	 * @return     number
	 */
	public int getSessionNr();
	
	
	/**
	 * Al communication between the client and the server.
	 *
	 * @return     each object in the vector represents a line.
	 */	
	public Vector getConversation();

}