package server.commands;

import java.io.*;
import server.*;

public class Admin extends AbstractCommand{

	Server server = Server.instanceOf();

  public void carryOut(String order){
 		order = order.toLowerCase();
		boolean ok = false;
		
		if (order.lastIndexOf("-print_setup") != -1	) {
			command.run("200 START OF SETUP.CONF");
			command.run(Conf.getRoot().getXMLString());
			command.run("200 END OF SETUP.CONF");
			ok=true;
		}
		
		if (order.lastIndexOf("-dump") != -1	) {
			command.run("200 Configuration dumped to setup.conf");
			ok=true;
		}	
		
		if(order.lastIndexOf("-reload") != -1	) {
			Conf.reload();
			command.run("200 Configuration file reloaded");
			ok=true;
		}
		
		if (order.lastIndexOf("-reboot") != -1) {
			server.stop();
			try {
				/* If we dosn't sleep here, the start and stop calls to server.services.Dock
				 * will in some cases go wrong, because Dock is a thead, and isn't finished
				 * stopping before we ask it to start again. It cannot be synchronized, because
				 * start() dosn't end before we call stop again.
				 */
				Thread.sleep(250);
			}catch(InterruptedException ie) {
			}
			server.start();
			ok=true;
		}
		
		if (ok)
			return;
		
		//if (order.lastIndexOf("-?") != -1 || order.lastIndexOf("/?") != -1 || order.equals("")){
			String[] a = {"200 -reload      -> reloads the configuration file. All changes that were made on the server is lost",
										"200 -reboot      -> reboots the server.",
										"200 -dump        -> forces the server to dump its current configuration into the configuration file",
										"200 -print_setup -> Prints the entire configuration file over the command-connection starting and ending with a '200' command",
										
									 };
			command.run(a);
		
  }
	
  public int countUp() {
  	return 0;
  }
}