package server.commands;

import java.io.*;
import java.util.*;

import server.services.tree.*;

public class List extends AbstractCommand{
  
  private StringBuffer buf;
  
	public void carryOut(String order){
    
		if (command.DataSocketInUse() == false){
			Object[] obj = ses.fileSystem.getList();
			
			if (obj == null) {
				command.run("426 No Directories specified for user.");
				return;
	    }
			
	    //Tret skrives til et nyt array af objects.
	    
	    File temp;
	    buf = new StringBuffer(3000);
    //arrayet af objects lgges over i et array af Strings med strrels dato osv.				
      for(int i = 0 ; i< obj.length ; i++){
        temp = (File) obj[i];
        buf.append( fileLister(temp) + "\r\n");
      }
      
      //IF-stning er der, da der har vist sig fejl ved gentagne lists p min PC.
      if (command.sendList( buf.toString().getBytes() ) == false){
        command.run("426 Data connection closed, transfer aborted.");
      }
		}
		else
      command.run("425 Try later, data connection in use.");
  }
  
  private String fileLister(File inst){
    int distances[] = {3,10};
    String complete="";
    
    //Directory-Read-Write-Hidden
    if (inst.isDirectory())
      complete+="d";
    else
      complete+="-";    
    if (inst.canRead())
      complete+="r";
    else
      complete+="-";
    if (inst.canWrite())
      complete+="w";
    else
      complete+="-";
    
//    if (inst.isHidden())
//      complete+="H";
//    else
//      complete+="-";

    complete+="x------ 1 Users   Group";
  
    complete+=space(distances[0]);
    
    //Strrese
    String l =""+ inst.length();
    complete+=space(distances[1]-l.length()) + inst.length() + " ";
    
    //Dato
    Calendar date = Calendar.getInstance();
    String[] mdr= {"Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"};
    date.setTime(new Date(inst.lastModified()));
    complete+= mdr[date.get(date.MONTH)] + " ";
    
    //Skriver DagsDato    
    if ( date.get(date.DATE) < 10  )
      complete+= " ";
      complete+= date.get(date.DATE) + " ";
          
    // Skriver Tid el. dato.
    Calendar now = Calendar.getInstance();
    if ( date.get(date.YEAR) == now.get(now.YEAR) ){
      if ( date.get(date.HOUR_OF_DAY) < 10  )
        complete+= "0";
        complete+= date.get(date.HOUR_OF_DAY) + ":";
      if ( date.get(date.MINUTE) < 10  )
        complete+= "0";
        complete+= date.get(date.MINUTE) + " ";
    }else
      complete+= " " + date.get(date.YEAR) + " ";

    //navn
    complete+= inst.getName();
    
    return complete;
  }
  
  private String space(int x){
    String complete="";
    while(x>0){
      complete+=" ";
      x--;
    }
    return complete;
  }
}