package server.event;

import setup.*;
import java.io.*;
import java.util.*;

/**
 * Klassen bruges af den som skal tage sig af serverens FejlEvents. 
 * Den er lidt speciel, da det kan lade sig gre ikke at hndtere FejlEvents.
 * Metoden setInstance(BigBrother b) gr det muligt at stte en anden klasse af typen BigBrother,
 * til den, som skal hndtere FejlEvents. Metodenavnene afspejler hvorfra fejlene kommer.
 */
public class BigBrother extends Observable{
  
  private static BigBrother bigBrother;
  
  private BigBrother(){
  }
  
  public void dockException(Exception e, String classMessage) {
		tellEm(e);
  }
  
  public void probeException(Exception e, String classMessage) {
		tellEm(e + " " + classMessage);
  }
	
	public void tagException(Exception e, String classMessage) {
		tellEm(e);
		if       (e instanceof IOException) {
			
		}else if (e instanceof NumberFormatException) {
			
		}else if (e instanceof NoSuchTagException) {
			
		}
	}
	
	public void commandException(Exception e, String classMessage) {
		tellEm(e + " " + classMessage);
	}
	
	public void sessionException(Exception e, String classMessage) {
		tellEm(e + " " + classMessage);
	}
	
	public void commandoException(Exception e, String classMessage) {
		tellEm(e + " " + classMessage);
	}
	
	public void message(String classMessage) {
		tellEm(classMessage);
	}
	
	public void fileHandlerException(Exception e, String classMessage) {
		tellEm(e + " " + classMessage);
	}
	
	public void LogFileExcption(Exception e, String classMessage) {
		tellEm(e + " " + classMessage);
	}
  
  public static BigBrother getInstance(){
    if (bigBrother == null)
      bigBrother = new BigBrother();
    return bigBrother;
  }
	
	private void tellEm(Object o) {
		setChanged();
		notifyObservers(o);
	}
}