package server.event;

import server.*;


/**
 * Shold be implemented by the ones, that wants to listen on a server object!
 *
 */
public interface ServerObserver {

	/**
	 * The method is called when a new client connects to the FTP-Server.
	 *
	 * @param   userSession  the client
	 */
	public void clientConnected(UserSession userSession);
	

	/**
	 * The method is called when a clients disconnects from the FTP-Server
	 *
	 * @param   userSession  the client
	 */
	public void clientDisconnected(UserSession userSession);
	
	

	/**
	 * Indicated that the server has been attemped started
	 *
	 * @param   startedOk  whether the server has started successfully or not.
	 */
	public void serverStarted(boolean startedOk);
	

	/**
	 * The server has been stoped!
	 *
	 */
	public void serverStoped();
}