package server.services;

import server.*;
import server.commands.*;

public class Chain{
	
	private static AbstractCommand data,login;
	
	private AbstractCommand[] dataClasses = {new Mdtm(), new Stat(), new Quit(), new Size(), new Rein(), new Abor(),
							      new Help(), new Type(), new Nlst(), new Pwd(), new Cdup(), new Dele(), new Rnfr(), new Rnto(), new Appe(),
								new Rest(), new Stor(), new Retr(), new Port(), new Noop(), new Mkd(), new Rmd(), new Allo(), new Syst(), new Pasv(),
								new List(), new Cwd(), new Unknown() };

	private AbstractCommand[]  loginClasses ={new Pass(), new User(), new NotLogedIn()};
	
	private Session ses;
	private Command command;
	
	
	public Chain(Session ses, Command command){
		this.ses = ses;
		this.command = command;
		
		if ( data == null) {
			data = makeChain(dataClasses);
			login = makeChain(loginClasses);
		}
	}
	
	public static void saveChains() {
		if (data != null) {
			data.save();
			login.save();
		}
	}
	
	public static void sortChains() {
		if (data != null) {
			data = data.sort();
			login = login.sort();
		}
	}

  public AbstractCommand getDataChain(){
		return data.clone(ses,command);
	}
	
	public AbstractCommand getLoginChain(){
		return login.clone(ses,command);
	}
	
	private AbstractCommand makeChain(AbstractCommand[] arr) {
		AbstractCommand c = arr[0];
		c.build(ses,command);
		
		for(int i = 1  ; i < arr.length ; i++){
			c.addCommandLast(arr[i]);
		}
		c = c.sort();
		return c;
	}

	
}