package server.services;

import java.io.*;
import java.util.*;
import server.event.*;

import server.*;

public class ExtendedUserSession extends UserSession {

	protected void set(Session ses, Command com) {
		super.set(ses,com);
	}

	protected void commandUpdate(String command) {
		Iterator i = obs.iterator();
		while (i.hasNext()) {
			((UserSessionObserver)i.next()).commandUpdate(command);
		}
	}
	
	protected void serverResponse(String response) {
		Iterator i = obs.iterator();
		while (i.hasNext()) {
			((UserSessionObserver)i.next()).serverResponse(response);
		}
	}
	
	protected void fileTransferStarted(File file) {
		Iterator i = obs.iterator();
		while (i.hasNext()) {
			((UserSessionObserver)i.next()).fileTransferStarted(file);
		}
	}

	protected void fileTransferEnded(boolean successfull) {
		Iterator i = obs.iterator();
		while (i.hasNext()) {
			((UserSessionObserver)i.next()).fileTransferEnded(successfull);
		}
	}

	protected void bytesTransmitted(long[] arr) {
		Iterator i = obs.iterator();
		while (i.hasNext()) {
			((UserSessionObserver)i.next()).bytesTransmitted(arr);
		}
	}
	
	protected void userLogedIn() {
		Iterator i = obs.iterator();
		while (i.hasNext()) {
			((UserSessionObserver)i.next()).userLogedIn(this);
		}
	}
	
	protected void userLogedOut() {
		Iterator i = obs.iterator();
		while (i.hasNext()) {
			((UserSessionObserver)i.next()).userLogedOut(this);
		}
	}
	
	public void userDisconnected(int reasonCode) {
		if (super.state==-1) {
			super.state = reasonCode;
			Iterator i = obs.iterator();
			while (i.hasNext()) {
				((UserSessionObserver)i.next()).userDisconnected(this, reasonCode);
			}
		}
	}
}